---------------------------------------------------------
-- RESSOURCE : Admin Menu - Airport Wars
-- VERSION : 1.0
-- AUTEURS : Lobix300
--
-- Admin Menu for the Airport Wars server.
--------------------------------------------------------
-------------------------------------- EVENTS -----------------------------------------
RegisterServerEvent("airportwars:scadmin:kickplayer")
AddEventHandler("airportwars:scadmin:kickplayer", function(player, reason)
    if (reason == "") then
        TriggerClientEvent("airportwars:notify", source, "PLY_BEEN_KICKED", -1, {PatchPlayerName(0, GetPlayerName(player)), "No reason specified"}, "CHAR_SOCIAL_CLUB", 0, "Airport Wars Team", "Success", 1.0, true)
        TriggerClientEvent("airportwars:notify", player, "KICKED_FROM_APW", -1, {}, "CHAR_SOCIAL_CLUB", 0, "Airport Wars Team", "Warning", 2.0, true)
        TriggerClientEvent("airportwars:closegame", player)
        TriggerEvent("airportwars:discord:message", "**"..GetPlayerName(player).."** has been kicked for the following reason: No reason specified.", true)
        print("\nAPW_SCADMIN: "..tostring(GetPlayerName(player)).."/"..tostring(identifier).." has been kicked for the following reason: No reason specified.")
    else
        TriggerClientEvent("airportwars:notify", source, "PLY_BEEN_KICKED", -1, {PatchPlayerName(0, GetPlayerName(player)), reason}, "CHAR_SOCIAL_CLUB", 0, "Airport Wars Team", "Success", 1.0, true)
        TriggerClientEvent("airportwars:notify", player, "KICKED_FROM_APW", -1, {}, "CHAR_SOCIAL_CLUB", 0, "Airport Wars Team", "Warning", 2.0, true)
        TriggerClientEvent("airportwars:closegame", player)
        TriggerEvent("airportwars:discord:message", "**"..GetPlayerName(player).."** has been kicked for the following reason: "..string.lower(reason)..".", true)
        print("\nAPW_SCADMIN: "..tostring(GetPlayerName(player)).."/"..tostring(identifier).." has been kicked for the following reason: ".. string.lower(reason) ..".")
    end
end)

RegisterServerEvent("airportwars:scadmin:banplayer")
AddEventHandler("airportwars:scadmin:banplayer", function(player, reason)
    local source = source
    local player = player
    local identifier = GetPlayerIdentifiers(player)[1]
    exports["mysql"]:QueryAsync("INSERT INTO apw_bans (identifier, name, reason) VALUES (@identifier, @name, @reason)", {['@identifier'] = identifier, ['@name'] = GetPlayerName(player), ['@reason'] = reason}, function(done)
        TriggerClientEvent("airportwars:notify", source, "PLY_BEEN_BANNED", -1, {PatchPlayerName(0, GetPlayerName(player)), reason}, "CHAR_SOCIAL_CLUB", 0, "Airport Wars Team", "Success", 1.0, true)
        TriggerClientEvent("airportwars:notify", player, "BANNED_FROM_APW", -1, {}, "CHAR_SOCIAL_CLUB", 0, "Airport Wars Team", "Warning", 2.0, true)
        TriggerClientEvent("airportwars:closegame", player)
        TriggerEvent("airportwars:discord:message", "**"..GetPlayerName(player).."** has been banned for: "..string.lower(reason)..".", true)
        print("\nAPW_SCADMIN: "..tostring(GetPlayerName(player)).."/"..tostring(identifier).." has been banned for ".. string.lower(reason) ..".")
    end)
end)

RegisterServerEvent("airportwars:scadmin:restartobjectives")
AddEventHandler("airportwars:scadmin:restartobjectives", function()
    local rs = StopResource("airportwars_obj")
    while not rs do
        Wait(0)
    end
    local rs = StartResource("airportwars_obj")
    while not rs do
        Wait(0)
    end
    TriggerClientEvent("airportwars:objectives:tempfix", -1)
end)

RegisterServerEvent("airportwars:scadmin:patchhudobjectives")
AddEventHandler("airportwars:scadmin:patchhudobjectives", function()
    TriggerClientEvent("airportwars:objectives:tempfix", -1)
end)

RegisterServerEvent("airportwars:scadmin:freezetime")
AddEventHandler("airportwars:scadmin:freezetime", function(freeze)
    TriggerEvent("airportwars:weather:freezetime", freeze)
end)

RegisterServerEvent("airportwars:scadmin:overridetime")
AddEventHandler("airportwars:scadmin:overridetime", function(time)
    TriggerEvent("airportwars:weather:overridetime", time)
end)

RegisterServerEvent("airportwars:scadmin:overrideweather")
AddEventHandler("airportwars:scadmin:overrideweather", function(weather)
    TriggerEvent("airportwars:weather:overrideweather", weather)
end)

RegisterServerEvent("airportwars:scadmin:dropcrate")
AddEventHandler("airportwars:scadmin:dropcrate", function()
    --
end)

RegisterServerEvent("airportwars:scadmin:dropvehicle")
AddEventHandler("airportwars:scadmin:dropvehicle", function()
    --
end)
---------------------------------------------------------------------------------------
