local crate = nil --object
local crateblip = nil --blip
local crateDetails = nil --details from server

RegisterNetEvent("airportwars:crates:recievecrate")
AddEventHandler("airportwars:crates:recievecrate", function(crateSpawn, crateCoords)
-- This function will create the crate on the client, it will call when the server drops a crate
crateDetails = crateSpawn
if (crate == nil and not DoesEntityExist(crate)) then
	--Create the object in the world
        RequestModel(-739654066) --Advanced Crate from Gunning Run update
        crate = CreateObjectNoOffset(-739654066, crateCoords.x, crateCoords.y, crateCoords.z, 1, 0, 0)
        PlaceObjectOnGroundProperly(crate)
        SetEntityCollision(crate, true, true)
        FreezeEntityPosition(crate, true)
    --Create the blip on the client
        crateblip = AddBlipForEntity(crate)
        SetBlipSprite(crateblip, 306)
        SetBlipAsShortRange(crateblip, false)
        SetBlipColour(crateblip, crateSpawn.blipcolor)
        SetBlipFlashes(crateblip, true)
        SetBlipFlashTimer(crateblip, 5000)
        SetBlipScale(crateblip, 1.6)
        BeginTextCommandSetBlipName("STRING")
        AddTextComponentString("Crate Drop")
        EndTextCommandSetBlipName(crateblip)
        -- Optionally enhance this notification, through scaleform or whatever looks better
        PlaySoundFrontend(-1, "CONFIRM_BEEP", "HUD_MINI_GAME_SOUNDSET", true)
        SetNotificationTextEntry("STRING")
        AddTextComponentString("A "..crateSpawn.color..""..string.lower(crateSpawn.type).." ~w~supply crate ~w~has been dropped, it has been marked on your map!")
        DrawNotification(false, true)
    end
    end)

RegisterNetEvent("airportwars:crates:forcedeletespawnedcrate")
AddEventHandler("airportwars:crates:forcedeletespawnedcrate", function(message)
-- This function will create the crate on the client, it will call when the server drops a crate
if DoesEntityExist(crate) or crate ~= nil then
	DeleteObject(crate)
	crate = nil
end
if DoesBlipExist(crateblip) or crateblip ~=nil then
	RemoveBlip(crateblip)
	crateblip = nil
end
SetNotificationTextEntry("STRING")
AddTextComponentString(message)
DrawNotification(false, true)
end)

local function DisplayHelpTextThisFrame(text)
    BeginTextCommandDisplayHelp("STRING")
    AddTextComponentScaleform(text)
    EndTextCommandDisplayHelp(0, 0, 0, -1)
end

Citizen.CreateThread(function()
	local playSound = true
	while true do
		Citizen.Wait(0)
		if (crate ~= nil and DoesEntityExist(crate)) then
			crateCoords = GetEntityCoords(crate)
			DrawMarker(0, crateCoords.x, crateCoords.y, crateCoords.z+1.5, 0, 0, 0, 0, 0, 0, 0.75, 0.75, 0.75, 242, 225, 144, 200, true, 0, 0, 0)
			local plyCoords = GetEntityCoords(GetPlayerPed(-1), false)
			local dis = Vdist(plyCoords.x, plyCoords.y, plyCoords.z, crateCoords.x, crateCoords.y, crateCoords.z)
			if dis <= 2 then
				DisplayHelpTextThisFrame("Press ~INPUT_CELLPHONE_SELECT~ to loot the supply crate!")
				if IsControlJustPressed(3,176) then
					--Enter has been pressed
					TriggerEvent("airportwars:crates:forcedeletespawnedcrate", "You have acquired the "..crateDetails.color..""..string.lower(crateDetails.type).."~w~ supply crate! You got ~n~-$"..crateDetails.money.." ~n~-"..string.lower(crateDetails.type).." weapons!")
					TriggerServerEvent("airportwars:crates:success")
					for i, weps in ipairs(crateDetails.weapons) do
						GiveWeaponToPed(PlayerPedId(), weps, 100, false, false)
					end
					PlaySoundFrontend(-1, "Mission_Pass_Notify", "DLC_HEISTS_GENERAL_FRONTEND_SOUNDS", true)
				end
			end
		end
	end
end)


