---------------------------------------------------------
-- RESSOURCE : Scoreboard - Airport Wars
-- VERSION : 1.0
-- AUTEURS : Lobix300 & Rox10
--
-- Scoreboard script for the Airport Wars server.
---------------------------------------------------------
------------------------------------- FUNCTIONS --------------------------------------
local function sortscore(pair1, pair2)
	return tonumber(pair1.score) > tonumber(pair2.score)
end

local function BuildScoreboard()
    local scoreboard = {}
    TriggerEvent("airportwars:sys:getusers", function(players)
        for k, v in pairs(players) do
            TriggerEvent("airportwars:sys:getuserfromid", k, function(Network)
                k = {}
                k.rank = Network.GetInfo("RANK_STRING")
                k.name = GetPlayerName(Network.GetInfo("SOURCE_ID"))
                k.team = Network.GetInfo("TEAM")
                k.score = tostring(round(Network.GetStatFromString("SCORE")))
                k.kills = tostring(round(Network.GetStatFromString("KILLS")))
                k.deaths = tostring(round(Network.GetStatFromString("DEATHS")))
                k.money = "$"..tostring(round(Network.GetStatFromString("WALLET_BALANCE")))
                table.insert(scoreboard, k)
            end)
        end
    end)
    return scoreboard
end
---------------------------------------------------------------------------------------


-------------------------------------- EVENTS -----------------------------------------
RegisterServerEvent("airportwars:scoreboard:refresh")
AddEventHandler("airportwars:scoreboard:refresh", function()
    local scoreboard = BuildScoreboard()
    table.sort(scoreboard, sortscore)
    TriggerClientEvent("airportwars:scoreboard:refresh", -1, scoreboard)
end)

RegisterServerEvent("airportwars:scoreboard:get")
AddEventHandler("airportwars:scoreboard:get", function()
    local scoreboard = BuildScoreboard()
    TriggerClientEvent("airportwars:scoreboard:refresh", source, scoreboard)
end)
---------------------------------------------------------------------------------------
