---------------------------------------------------------
-- RESSOURCE : Skin Shop - Airport Wars
-- VERSION : 1.0
-- AUTEURS : Lobix300
--
-- Skin Shop for the Airport Wars server.
---------------------------------------------------------
------------------------------------- VARIABLES --------------------------------------
local binco = {}
local itemsloaded = false
--------------------------------------------------------------------------------------


------------------------------------- FUNCTIONS --------------------------------------
local function getSkins(identifier)
	  return exports["mysql"]:QueryScalar("SELECT skins FROM apw_outfits WHERE identifier = @identifier", {["@identifier"] = identifier})
end

local function getlastSkin(identifier)
	  return exports["mysql"]:QueryScalar("SELECT lastskin FROM apw_outfits WHERE identifier = @identifier", {["@identifier"] = identifier})
end

local function hebas(identifier)
	  return exports["mysql"]:QueryScalar("SELECT hebas FROM apw_outfits WHERE identifier = @identifier", {["@identifier"] = identifier})
end

local function buySkin(source, skinmodel, identifier)
  	local getSkins = getSkins(identifier)
  	local skins = {}
  	local skins = json.decode(getSkins)
  	table.insert(skins, skinmodel)
  	local new_skins = json.encode(skins)
  	exports["mysql"]:QueryAsync("UPDATE apw_outfits SET skins = @new_skins WHERE identifier = @identifier", {["@identifier"] = identifier, ["@new_skins"] = new_skins})
  	TriggerClientEvent("airportwars:skinshop:playerhavemoney", source, skinmodel)
end

local function getPrice(cat, ind)
		if (cat == "general") then
				return binco.general[ind].price
		elseif (cat == "special") then
				return binco.special[ind].price
		end
end
---------------------------------------------------------------------------------------


-------------------------------------- EVENTS -----------------------------------------
RegisterServerEvent("airportwars:skinshop:getlist")
AddEventHandler("airportwars:skinshop:getlist", function(source)
		while not itemsloaded do
				Wait(0)
		end
		for k, v in pairs(binco) do
				for k, v in pairs(v) do
						if (v.price ~= nil) then
								v.price = round(v.price * NetworkAccessTunable("CLOTHES_SHOP_MULTIPLIER"))
						end
				end
		end
		TriggerClientEvent("airportwars:skinshop:getlist", source, binco.general, binco.special)
end)

RegisterServerEvent("airportwars:skinshop:checkmoney")
AddEventHandler("airportwars:skinshop:checkmoney", function(skinmodel, clientprice, category, ind)
		local source = source
		local price = getPrice(category, ind)
		if (price ~= clientprice) then
				TriggerEvent("airportwars:anticheat:flagged", source, "Cheating Skin Shop Prices")
				return
		end
		local identifier = GetPlayerIdentifiers(source)[1]
		local getSkins = getSkins(identifier)
		local skins = {}
    local skins = json.decode(getSkins)
		local test = tablecontains(skins, skinmodel)
		if tablecontains(skins, skinmodel) then
        --TriggerClientEvent("airportwars:notify", source, "BIN_OWN_SKIN", -1, {}, "CHAR_HITCHER_GIRL", 0, "Outfit Changer", "", 0.3)
        TriggerClientEvent("airportwars:skinshop:playerhavemoney", source, skinmodel)
				exports["mysql"]:QueryAsync("UPDATE apw_outfits SET lastskin = @lastskin WHERE identifier = @identifier", {["@identifier"] = identifier, ["@lastskin"] = skinmodel})
		else
				TriggerEvent("airportwars:sys:getuserfromid", source, function(Network)
      			if (Network.GetStatFromString("WALLET_BALANCE") >= price) then
        				buySkin(source, skinmodel, identifier)
        				Network.RemoveFromWalletBalance(price)
      			--elseif (Network.GetStatFromString("BANK_BALANCE") >= price) then
        		--		buySkin(source, skinmodel, identifier)
        		--		Network.RemoveFromBankBalance(price)
                exports["mysql"]:QueryAsync("UPDATE apw_outfits SET lastskin = @lastskin WHERE identifier = @identifier", {["@identifier"] = identifier, ["@lastskin"] = skinmodel})
                local hebas = hebas(identifier)
                if not (hebas) then
                    exports["mysql"]:QueryAsync("UPDATE apw_outfits SET hebas = 1 WHERE identifier = @identifier", {["@identifier"] = identifier})
                end
								print("\nAPW_BINCO: "..tostring(GetPlayerName(source)).." purchased the skin model "..tostring(skinmodel)..", $"..tostring(price).." taken from his wallet.")
      			else
      				  TriggerClientEvent("airportwars:notify", source, "BIN_NOT_MONEY", -1, {}, "CHAR_HITCHER_GIRL", 0, "Outfit Changer", "", 0.3, false)
      			end
				end)
		end
end)

RegisterServerEvent("airportwars:skinshop:resetlastskin")
AddEventHandler("airportwars:skinshop:resetlastskin", function(skintoset)
		local identifier = GetPlayerIdentifiers(source)[1]
		exports["mysql"]:QueryAsync("UPDATE apw_outfits SET lastskin = @lastskin WHERE identifier = @identifier", {["@identifier"] = identifier, ["@lastskin"] = skintoset})
end)

RegisterServerEvent("airportwars:skinshop:checklastskin")
AddEventHandler("airportwars:skinshop:checklastskin", function()
		local source = source
		local identifier = GetPlayerIdentifiers(source)[1]
    local hebas = hebas(identifier)
    if (hebas) then
        local lastSkin = getlastSkin(identifier)
        if (lastSkin ~= "S_M_Y_Marine_01") or (lastSkin ~= "S_M_Y_Swat_01") then
            TriggerClientEvent("airportwars:skinshop:setlastskin", source, lastSkin)
        end
    end
end)
---------------------------------------------------------------------------------------


-------------------------------------- THREADS ----------------------------------------
CreateThread(function()
		while not StoreFileLoaded do
				Wait(0)
		end
		binco = json.decode(GetItemsList("binco"))
		itemsloaded = true
end)
---------------------------------------------------------------------------------------
