--{name="Buy Ammo", desc="Fastly buy ammo for your weapons. (x100 for 0$)", type=4, type=1, list={"Handguns", "Shotguns", "Submachine Guns", "Assault Rifles", "Sniper Rifles"}, event="airportwars:weapons:fastammo", id=1},
--{name="x1 Smoke Grenade", price=150, desc="Features armor-piercing rounds for heavy damage. Comes with laser scope as standard.", type=1, model="WEAPON_SMOKEGRENADE", gxtname="WEP_HVSNIPER", id=3},

local ammunation = {
    categories = {
        {name="Melee", desc="Buy Melee weapons.", type=5, event="airportwars:weapons:categories", id=2},
        {name="Handguns", desc="Buy Handguns.", type=5, event="airportwars:weapons:categories", id=3},
    		{name="Shotguns", desc="Buy Shotguns.", type=5, event="airportwars:weapons:categories", id=4},
    		{name="Machine Guns", desc="Buy Machine Guns", type=5, event="airportwars:weapons:categories", id=5},
    		{name="Assault Rifles", desc="Buy Assault Rifles.", type=5, event="airportwars:weapons:categories", id=6},
    		{name="Sniper Rifles", desc="Buy Sniper Rifles.", type=5, event="airportwars:weapons:categories", id=7},
    		{name="Heavy Weapons", desc="Buy Heavy Weapons.", type=5, event="airportwars:weapons:categories", id=8},
        {name="Thrown Weapons", desc="Buy Thrown Weapons.", type=5, event="airportwars:weapons:categories", id=9},
        {name="Buy Special Ammo", desc="Buy special weapons & ammo.", type=5, event="airportwars:weapons:categories", id=10}
    },
    melee = {
        {name="Knife", price=200, desc='This carbon steel 7" bladed knife is dual edged with a serrated spine.', type=1, model="WEAPON_KNIFE", gxtname="WT_KNIFE", id=1},
    		{name="Nightstick", price=400, desc='24" polycarbonated side-handled nightstick.', type=1, model="WEAPON_NIGHTSTICK", gxtname="WT_NGTSTK", id=2}
    },
    handgun = {
    		{name="Pistol", price=1000, desc="Standard handgun. A .45 caliber pistol with a magazine capacity of 12 rounds.", type=1, model="WEAPON_PISTOL", gxtname="WT_PIST", id=1},
    		{name="Combat Pistol", price=1200, desc="A compact, lightweight semi-automatic pistol designed for law enforcement and personal defense use.", type=1, model="WEAPON_COMBATPISTOL", gxtname="WT_PIST_CBT", id=2},
    		{name="AP Pistol", price=3500, desc="High-penetration, fully-automatic pistol. Holds 18 rounds in magazine.", type=1, model="WEAPON_APPISTOL", gxtname="WT_PIST_AP", id=3},
    		{name="Pistol .50", price=2000, desc="High-impact pistol that delivers immense power but with extremely strong recoil.", type=1, model="WEAPON_PISTOL50", gxtname="WT_PIST_50", id=4},
        {name="x100 Handgun Ammo", price=500, desc="Buy x100 ammo for your handguns.", type=1, list={453432689, 3219281620, 1593441988, -1716589765, -1076751822, -771403250, 137902532, -598887786, -1045183535, 584646201}, id=5}
    },
    shotgun = {
    		{name="Pump Shotgun", price=3000, desc="Standard shotgun ideal for short-range combat.", type=1, model="WEAPON_PUMPSHOTGUN", gxtname="WT_SG_PMP", id=1},
    		{name="Sawed-Off Shotgun", price=500, desc="This single-barrel, sawed-off shotgun compensates for its low range and ammo capacity.", type=1, model="WEAPON_SAWNOFFSHOTGUN", gxtname="WT_SG_SOF", id=2},
    		{name="Assault Shotgun", price=4500, desc="Fully automatic shotgun with 8 round magazine and high rate of fire.", type=1, model="WEAPON_ASSAULTSHOTGUN", gxtname="WT_SG_ASL", id=3},
    		{name="Bullpup Shotgun", price=3000, desc="More than makes up for its slow, pump-action rate of fire with its range and spread.", type=1, model="WEAPON_BULLPUPSHOTGUN", gxtname="WT_SG_BLP", id=4},
        {name="x100 Shotgun Ammo", price=1000, desc="Buy x100 ammo for your shotguns.", type=1, list={487013001, 2017895192, -1654528753, -494615257, -1466123874, 984333226, -275439685, 317205821}, id=5}
    },
    submachine = {
    		{name="Micro SMG", price=4000, desc="Combines compact design with a high rate of fire at approximately 700-900 rounds per minute.", type=1, model="WEAPON_MICROSMG", gxtname="WT_SMG_MCR", id=1},
    		{name="SMG", price=2000, desc="This is known as a good all-around submachine gun. Lightweight with an accurate sight.", type=1, model="WEAPON_SMG", gxtname="WT_SMG", id=2},
    		{name="Assault SMG", price=3000, desc="A high-capacity submachine gun that is both compact and lightweight.", type=1, model="WEAPON_ASSAULTSMG", gxtname="WT_MG_ASL", id=3},
    		{name="MG", price=5000, desc="General purpose machine gun that combines rugged design with dependable performance.", type=1, model="WEAPON_MG", gxtname="WT_MG", id=4},
    		{name="Combat MG", price=5500, desc="Lightweight, compact machine gun.", type=1, model="WEAPON_COMBATMG", gxtname="WT_MG_CBT", id=5},
        {name="x100 Machine Guns Ammo", price=1250, desc="Buy x100 ammo for your machine guns.", type=1, list={324215364, -619010992, 736523883, 2024373456, -270015777, 171789620, -1660422300, 2144741730, 3686625920, 1627465347, 1121678507}, id=6}
    },
    assault = {
    		{name="Assault Rifle", price=1000, desc="This standard assault rifle boasts a large capacity magazine and long distance accuracy.", type=1, model="WEAPON_ASSAULTRIFLE", gxtname="WT_RIFLE_ASL", id=1},
    		{name="Carbine Rifle", price=1500, desc="Combining long distance accuracy with a high capacity magazine.", type=1, model="WEAPON_CARBINERIFLE", gxtname="WT_RIFLE_CBN", id=2},
    		{name="Advanced Rifle", price=2500, desc="The most lightweight and compact of all assault rifles.", type=1, model="WEAPON_ADVANCEDRIFLE", gxtname="WT_RIFLE_ADV", id=3},
        {name="x100 Rifle Ammo", price=1500, desc="Buy x100 ammo for your rifles.", type=1, list={-1074790547, 961495388, -2084633992, 4208062921, -1357824103, -1063057011, 2132975508, 1649403952}, id=4}
    },
    sniper = {
    		{name="Sniper Rifle", price=3500, desc="Standard sniper rifle. Ideal for situations that require accuracy at long range.", type=1, model="WEAPON_SNIPERRIFLE", gxtname="WT_SNIP_RIF", id=1},
    		{name="Heavy Sniper", price=7000, desc="Features armor-piercing rounds for heavy damage. Comes with laser scope as standard.", type=1, model="WEAPON_HEAVYSNIPER", gxtname="WT_SNIP_HVY", id=2},
        {name="x100 Rifle Ammo", price=2000, desc="Buy x100 ammo for your rifles.", type=1, list={100416529, 205991906, 177293209, -952879014}, id=3}
    },
    heavy = {
    		{name="Grenade Launcher", price=7000, desc="A compact, lightweight grenade launcher with semi-automatic functionality. Holds up to 10 rounds.", type=1, model="WEAPON_GRENADELAUNCHER", gxtname="WT_GL", id=1},
    		{name="RPG", price=8500, desc="A portable, shoulder-launched, anti-tank weapon that fires explosive warheads.", type=1, model="WEAPON_RPG", gxtname="WT_RPG", id=2},
    		{name="Homing Launcher", price=11000, desc="Infrared and guided fire-and-forget missile launcher. For all your moving target needs.", type=1, model="WEAPON_HOMINGLAUNCHER", gxtname=0xB2A66154, id=3}
    },
    thrown = {
        {name="x1 Grenade", price=300, desc="Standard sniper rifle. Ideal for situations that require accuracy at long range.", type=1, model="WEAPON_GRENADE", gxtname="WT_GNADE", id=1},
        {name="x1 Molotov Cocktail", price=150, desc="Features armor-piercing rounds for heavy damage. Comes with laser scope as standard.", type=1, model="WEAPON_MOLOTOV", gxtname="WT_MOLOTOV", id=2}
    },
    special_ammo = {
        {name="x1 Grenade for Grenade Launcher", type=1, model="WEAPON_GRENADELAUNCHER", price=700, id=1},
        {name="x1 Rocket for RPG", type=1, model="WEAPON_RPG", price=850, id=2},
    		{name="x1 Rocket for Homing Launcher", type=1, model=1672152130, price=1100, id=3}
    }
}

local binco = {
		general = {
			  {name="Default Team Skin", price=0, description="Your default team skin.", type=1, event="airportwars:skinshop:setdefaultskin", type=1, model="", id=1},
				{name="Army Mechanic", price=10000, description="", type=1, event="airportwars:skinshop:buyskin", type=1, model=1657546978, id=2},
				{name="Bulletproof Cop", price=7000, description="", type=1, event="airportwars:skinshop:buyskin", type=1, model=1669696074, id=3},
				{name="Pilot 1", price=8000, description="", type=1, event="airportwars:skinshop:buyskin", type=1, model=-413447396, id=4},
			  {name="Pilot 2", price=10000, description="", type=1, event="airportwars:skinshop:buyskin", type=1, model=-1422914553, id=5},
			  {name="Pilot 3", price=12000, description="", type=1, event="airportwars:skinshop:buyskin", type=1, model=-163714847, id=6},
			  {name="Guard", price=15000, description="", type=1, event="airportwars:skinshop:buyskin", type=1, model=1456041926, id=7},
			  {name="Black Ops 1", price=15000, description="", type=1, event="airportwars:skinshop:buyskin", type=1, model=-1275859404, id=8},
			  {name="Black Ops 2", price=20000, description="", type=1, event="airportwars:skinshop:buyskin", type=1, model=1349953339, id=9},
			  {name="Robber 1", price=30000, description="", type=1, event="airportwars:skinshop:buyskin", type=1, model=275618457, id=10},
			  {name="Cop 1", price=5000, description="", type=1, event="airportwars:skinshop:buyskin", type=1, model=1581098148, id=11},
			  {name="Cop 2", price=40000, description="", type=1, event="airportwars:skinshop:buyskin", type=1, model=1939545845, id=12},
			  {name="FIB", price=35000, description="", type=1, event="airportwars:skinshop:buyskin", type=1, model=1558115333, id=13},
			  {name="Marine 1", price=3000, description="", type=1, event="airportwars:skinshop:buyskin", type=1, model=-220552467, id=14},
			  {name="Marine 2", price=4000, description="", type=1, event="airportwars:skinshop:buyskin", type=1, model=1925237458, id=15},
			  {name="Marine 3", price=10000, description="", type=1, event="airportwars:skinshop:buyskin", type=1, model=1490458366, id=16},
			  {name="Marine 4", price=50000, description="", type=1, event="airportwars:skinshop:buyskin", type=1, model=-265970301, id=17},
			  {name="Special skins", desc="Buy Special Skins.", type=5, event="airportwars:skinshop:specialcategorie", id=18}
		},
		special = {
			  {name="Zombie", price=80000, description="", type=1, event="airportwars:skinshop:buyspecialskin", type=1, model=-1404353274, id=1},
				{name="Ape", price=100000, description="", type=1, event="airportwars:skinshop:buyspecialskin", type=1, model=1641334641, id=2},
				{name="Astronaut Monkey", price=500000, description="", type=1, event="airportwars:skinshop:buyspecialskin", type=1, model=-598109171, id=3},
				{name="RS Ranger", price=1000000, description="", type=1, event="airportwars:skinshop:buyspecialskin", type=1, model=1011059922, id=4}
		}
}

local pegasus = {
    categories = {
        {name="Free Vehicles", desc="Get a temporary free vehicles.", type=5, event="airportwars:pegasus:categories", id=1},
        {name="Armored Vehicles", desc="Buy permanant armored vehicles.", type=5, event="airportwars:pegasus:categories", id=2},
        {name="Military Vehicles", desc="Buy permanant military vehicles.", type=5, event="airportwars:pegasus:categories", id=3},
        {name="Sports Vehicles", desc="Buy permanant sports vehicles.", type=5, event="airportwars:pegasus:categories", id=4},
        {name="Motorcylces", desc="Buy permanant motorcycles.", type=5, event="airportwars:pegasus:categories", id=5},
        {name="Planes", desc="Buy permanant planes.", type=5, event="airportwars:pegasus:categories", id=6},
        {name="Helicopters", desc="Buy permanant helicoptes.", type=5, event="airportwars:pegasus:categories", id=7}
    },
    free = {
        {name="Free motorcycle", price=0, showprice="FREE", desc="A free motorcycle.", event="airportwars:pegasus:buyfreevehicle", type=1, model=11251904, blipid=226, type="motorcycle"},
      	{name="Free car", price=0, showprice="FREE", desc="A free car.", event="airportwars:pegasus:buyfreevehicle", type=1, model=544021352, blipid=225, type="car"}
    },
    armored = {
        {name="Kuruma (Armored)", price=110000, desc="The perfect car to go with your flesh tunnel earrings, and frosted spikes.", event="airportwars:pegasus:buyarmoredvehicle", type=1, model=410882957, blipid=225, type="car"},
        {name="Duke O'Death", price=200000, desc="Special edition Dukes muscle car for the post-apocalypse wasteland.", event="airportwars:pegasus:buyarmoredvehicle", type=1, model=-326143852, blipid=225, type="car"},
      	{name="Insurgent", price=140000, desc="Ironically named light armored personnel vehicle.", event="airportwars:pegasus:buyarmoredvehicle", type=1, model=2071877360, blipid=426, type="guncar"},
        {name="Insurgent Pick-Up", price=220000, desc="Insurgent but fitted with a turret cannon.", event="airportwars:pegasus:buyarmoredvehicle", type=1, model=-1860900134, blipid=426, type="guncar"}
    },
    military = {
        {name="Rhino Tank", price=650000, desc="A heavily-armored battle tank with a 1,500hp turbine engine and a 120mm cannon.", event="airportwars:pegasus:buymilitaryvehicle", type=1, model=782665360, blipid=421, type="tank"},
      	{name="TM-02 Khanjali", price=1000000, desc="The Khanjali is a loud, fast wakeup call to get our priorities straight.", event="airportwars:pegasus:buymilitaryvehicle", type=1, model=-1435527158, blipid=421, type="tank"}
    },
    sports = {
        {name="Infernus Classic", price=100000, desc="Experience tells you that anything this hot must be crazy, and you're not wrong. Buy it now.", event="airportwars:pegasus:buysportvehicle", type=1, model=-1405937764, blipid=225, type="car"},
      	{name="Banshee", price=20000, desc="You can weave in and out of traffic with ease in this little number.", event="airportwars:pegasus:buysportvehicle", type=1, model=-1041692462, blipid=225, type="car"},
        {name="Obey 9F", price=15000, desc="There's nothing wrong with the standard Obey 9F.", event="airportwars:pegasus:buysportvehicle", type=1, model=1032823388, blipid=225, type="car"}
    },
    motorcycles = {
        {name="Akuma", price=30000, desc="A Japanese crotch rocket sure to please the ladies.", event="airportwars:pegasus:buymotorcycle", type=1, model=1672195559, blipid=226, type="motorcycle"},
        {name="Bati 801", price=45000, desc="Do the 0-80 in 2.3 seconds with this type=1, model from Liberty City.", event="airportwars:pegasus:buymotorcycle", type=1, model=-114291515, blipid=226, type="motorcycle"},
        {name="Sanchez", price=50000, desc="If you want a ride that really leaves a mark on the track, this is the bike for you.", event="airportwars:pegasus:buymotorcycle", type=1, model=788045382, blipid=226, type="motorcycle"},
        {name="Hakuchou", price=145000, desc="This super-fast sports bike can take you from 0 to permanent vegetative state in under 2.5 seconds.", event="airportwars:pegasus:buymotorcycle", type=1, model=1265391242, blipid=226, type="motorcycle"}
    },
    planes = {
        {name="Dodo", price=70000, desc="Take to the skies in this powerful and versatile 4-seater aircraft.", event="airportwars:pegasus:buyplane", type=1, model=-901163259, blipid=251, type="plane"},
      	{name="Besra", price=90000, desc="High performance jet trainer aircraft.", event="airportwars:pegasus:buyplane", type=1, model=1824333165, blipid=16, type="plane"}
    },
    helicopters = {
        {name="Buzzard", price=650000, desc="The Buzzard is a light, compact helicopter for military or millionaire use.", event="airportwars:pegasus:buyhelicopter", type=1, model=788747387, blipid=64, type="heli"},
      	{name="Valkyrie", price=760000, desc="Instantly recognizable to any connoisseur of military-themed action movies.", event="airportwars:pegasus:buyhelicopter", type=1, model=-1600252419, blipid=64, type="heli"}
    }
}

CreateThread(function()
    exports["mysql"]:QueryAsync("UPDATE apw_shops SET items = @items WHERE id = 1", {["@items"] = json.encode(ammunation)})
    exports["mysql"]:QueryAsync("UPDATE apw_shops SET items = @items WHERE id = 2", {["@items"] = json.encode(binco)})
    exports["mysql"]:QueryAsync("UPDATE apw_shops SET items = @items WHERE id = 3", {["@items"] = json.encode(pegasus)})
end)
