---------------------------------------------------------
-- RESSOURCE : Gamemode - Airport Wars
-- VERSION : 1.0
-- AUTEURS : Lobix300
--
-- Just the stores blips for the Airport Wars server.
---------------------------------------------------------
------------------------------------- VARIABLES ---------------------------------------
local CanInitalizeStores = false
StoreFileLoaded = false
---------------------------------------------------------------------------------------


-------------------------------------- FUNCTIONS --------------------------------------
function GetItemsList(shop)
    return exports["mysql"]:QueryScalar("SELECT items FROM apw_shops WHERE shop = @shop", {["shop"] = shop})
end

local function InitializeAmmuNation(source)
    CreateThread(function()
        while not CanInitalizeStores do
            Wait(0)
        end
        TriggerEvent("airportwars:weapons:getlist", source)
    end)
end

local function InitializePegasus(source)
    CreateThread(function()
        while not CanInitalizeStores do
            Wait(0)
        end
        TriggerEvent("airportwars:pegasus:getlist", source)
    end)
end

local function InitializeBinco(source)
    CreateThread(function()
        while not CanInitalizeStores do
            Wait(0)
        end
        TriggerEvent("airportwars:skinshop:getlist", source)
    end)
end
---------------------------------------------------------------------------------------


-------------------------------------- EVENTS -----------------------------------------
CreateThread(function()
    while not HasTunablesBeenDownloaded() do
        NetworkRequestCloudTunables()
        Wait(0)
    end
    CanInitalizeStores = true
end)

RegisterServerEvent("airportwars:stores:initialize")
AddEventHandler("airportwars:stores:initialize", function(type)
    if (type == "ammunation") then
        InitializeAmmuNation(source)
    elseif (type == "pegasus") then
        InitializePegasus(source)
    elseif (type == "binco") then
        InitializeBinco(source)
    end
end)
---------------------------------------------------------------------------------------
StoreFileLoaded = true
