local TimeFreezed = false
local BlackoutEnabled = false
local NextWeatherStageTimer = 10
local ActualWeatherType = "EXTRASUNNY"
local Time = {h = 9, m = 0}

function GetNextWeatherType()
    if (ActualWeatherType == "CLEAR") or (ActualWeatherType == "CLOUDS") or (ActualWeatherType == "EXTRASUNNY")  then
        local NextWeather = math.random(1,2)
        if (NextWeather == 1) then
            ActualWeatherType = "CLEARING"
        else
            ActualWeatherType = "OVERCAST"
        end
    elseif (ActualWeatherType == "CLEARING") or (ActualWeatherType == "OVERCAST") then
        local NextWeather = math.random(1,6)
        if (NextWeather == 1) then
            if (ActualWeatherType == "CLEARING") then
                ActualWeatherType = "FOGGY"
            else
                ActualWeatherType = "RAIN"
            end
        elseif (NextWeather == 2) then
            ActualWeatherType = "CLOUDS"
        elseif (NextWeather == 3) then
            ActualWeatherType = "CLEAR"
        elseif (NextWeather == 4) then
            ActualWeatherType = "EXTRASUNNY"
        elseif (NextWeather == 5) then
            ActualWeatherType = "SMOG"
        else
            ActualWeatherType = "FOGGY"
        end
    elseif (ActualWeatherType == "THUNDER") or (ActualWeatherType == "RAIN") then
        ActualWeatherType = "CLEARING"
    elseif (ActualWeatherType == "SMOG") or (ActualWeatherType == "FOGGY") then
        ActualWeatherType = "CLEAR"
    end
    TriggerEvent("airportwars:weather:requestsync")
end

AirportWarsThread(2, function()
    if not TimeFreezed then
        Time.m = Time.m + 1
        if Time.m > 59 then
            Time.m = 0
            Time.h = Time.h + 1
            if Time.h > 23 then
                Time.h = 0
            end
        end
    end
end)

AirportWarsThread(5, function()
    TriggerClientEvent("airportwars:weather:updatetime", -1, Time.h, Time.m, TimeFreezed)
end)

AirportWarsThread(300, function()
    TriggerClientEvent("airportwars:weather:updateweather", -1, ActualWeatherType, BlackoutEnabled)
end)

AirportWarsThread(60, function()
    NextWeatherStageTimer = NextWeatherStageTimer - 1
    if (NextWeatherStageTimer == 0) then
        GetNextWeatherType()
        NextWeatherStageTimer = 10
    end
end)

RegisterServerEvent("airportwars:weather:requestsync")
AddEventHandler("airportwars:weather:requestsync", function()
    TriggerClientEvent("airportwars:weather:updateweather", -1, ActualWeatherType, BlackoutEnabled)
    TriggerClientEvent("airportwars:weather:updatetime", -1, Time.h, Time.m, TimeFreezed)
end)

RegisterServerEvent("airportwars:weather:freezetime")
AddEventHandler("airportwars:weather:freezetime", function(freeze)
    TimeFreezed = freeze
    TriggerEvent("airportwars:weather:requestsync")
end)

RegisterServerEvent("airportwars:weather:overridetime")
AddEventHandler("airportwars:weather:overridetime", function(newtime)
    Time.h = newtime
    TriggerEvent("airportwars:weather:requestsync")
end)

RegisterServerEvent("airportwars:weather:overrideweather")
AddEventHandler("airportwars:weather:overrideweather", function(newweather)
    ActualWeatherType = newweather
    TriggerEvent("airportwars:weather:requestsync")
end)
