---------------------------------------------------------
-- RESSOURCE : World - Airport Wars
-- VERSION : 1.0
-- AUTEURS : Lobix300
--
-- Do all the world stuff for the Airport Wars server.
---------------------------------------------------------
stepmap = 0
apw = {
  game = {
      setvoicechat = function()
          NetworkSetVoiceActive(true)
          --NetworkSetVoiceChannel(1)
          --NetworkSetTalkerProximity(SETTINGS.FEATURES.WORLD.PROXIMITY_VOICE_CHAT)
      end,
      disablevehrewards = function()
          DisablePlayerVehicleRewards(NetworkPlayerIdToInt())
      end,
      disablelsservices = function()
          SetDispatchCopsForPlayer(NetworkPlayerIdToInt(), false)
          EnableDispatchService(1, false)
          EnableDispatchService(2, false)
          EnableDispatchService(3, false)
          EnableDispatchService(4, false)
          EnableDispatchService(5, false)
          EnableDispatchService(6, false)
          EnableDispatchService(7, false)
          EnableDispatchService(8, false)
          EnableDispatchService(11, false)
          EnableDispatchService(12, false)
          EnableDispatchService(13, false)
          EnableDispatchService(14, false)
          EnableDispatchService(15, false)
      end,
  },
  map = {
    nblips = {
        {"Fort Zancudo Military Base", SETTINGS.COLORS.ZANCUDOTEAM[4], 557, -2087.862, 3118.197, 35.379},
        {"Los Santos International Airport", SETTINGS.COLORS.AIRPORTTEAM[4], 90, -1037.821, -2737.918, 20.169},
    },
    zones = {
        {-1821.974, 3128.297, 32.809},
        {-970.333, -3000.270, 13.945},
        {1368.974, 3128.297, 41.047}
    },
    nerftrafic = function()
        SetVehicleDensityMultiplierThisFrame(SETTINGS.FEATURES.WORLD.VEHICLE_DENSITY_MULTIPLAYER)
        SetRandomVehicleDensityMultiplierThisFrame(SETTINGS.FEATURES.WORLD.VEHICLE_DENSITY_MULTIPLAYER)
        SetParkedVehicleDensityMultiplierThisFrame(SETTINGS.FEATURES.WORLD.VEHICLE_PARKED_DENSITY_MULTIPLAYER)
        SetSomeVehicleDensityMultiplierThisFrame(SETTINGS.FEATURES.WORLD.VEHICLE_DENSITY_MULTIPLAYER)
        SetPedDensityMultiplierThisFrame(SETTINGS.FEATURES.WORLD.PED_DENSITY_MULTIPLAYER)
        SetScenarioPedDensityMultiplierThisFrame(SETTINGS.FEATURES.WORLD.PED_DENSITY_MULTIPLAYER, SETTINGS.FEATURES.WORLD.PED_DENSITY_MULTIPLAYER)
    end,
    showzancudo = function()
        SetMinimapComponent(15, 1, -1)
    end,
    createnblip = function()
        for i in ipairs(apw.map.nblips) do
            theblip = apw.map.nblips[i]
            blip = AddBlipForCoord(theblip[4], theblip[5], theblip[6])
            SetBlipSprite(blip, theblip[3])
            SetBlipDisplay(blip, 4)
            SetBlipScale(blip, 1.0)
            SetBlipColour(blip, theblip[2])
            SetBlipAsShortRange(blip, true)
            BeginTextCommandSetBlipName("STRING")
            AddTextComponentSubstringPlayerName(theblip[1])
            EndTextCommandSetBlipName(blip)
        end
    end,
    createzones = function()
        zancudozone = AddBlipForRadius(apw.map.zones[1][1], apw.map.zones[1][2], apw.map.zones[1][3], 400.0)
        SetBlipColour(zancudozone, SETTINGS.COLORS.ZANCUDOTEAM[4])
        SetBlipAlpha(zancudozone, 140)
        airportzone = AddBlipForRadius(apw.map.zones[2][1], apw.map.zones[2][2], apw.map.zones[2][3], 400.0)
        SetBlipColour(airportzone, SETTINGS.COLORS.AIRPORTTEAM[4])
        SetBlipAlpha(airportzone, 140)
        neutralzone = AddBlipForRadius(apw.map.zones[3][1], apw.map.zones[3][2], apw.map.zones[3][3], 400.0)
        SetBlipColour(neutralzone, 4)
        SetBlipAlpha(neutralzone, 140)
    end,
    requestipl = function()
        UseFreemodeMapBehavior(1)
        LoadMpDlcMaps()
      	RequestIpl("chop_props")
      	RequestIpl("FIBlobby")
      	RemoveIpl("FIBlobbyfake")
      	RequestIpl("FBI_colPLUG")
      	RequestIpl("FBI_repair")
      	RequestIpl("v_tunnel_hole")
      	RequestIpl("TrevorsMP")
      	RequestIpl("TrevorsTrailer")
      	RequestIpl("TrevorsTrailerTidy")
      	RemoveIpl("farm_burnt")
      	RemoveIpl("farm_burnt_lod")
      	RemoveIpl("farm_burnt_props")
      	RemoveIpl("farmint_cap")
      	RemoveIpl("farmint_cap_lod")
      	RequestIpl("farm")
      	RequestIpl("farmint")
      	RequestIpl("farm_lod")
      	RequestIpl("farm_props")
      	RequestIpl("facelobby")
      	RemoveIpl("CS1_02_cf_offmission")
      	RequestIpl("CS1_02_cf_onmission1")
      	RequestIpl("CS1_02_cf_onmission2")
      	RequestIpl("CS1_02_cf_onmission3")
      	RequestIpl("CS1_02_cf_onmission4")
      	RequestIpl("v_rockclub")
      	RemoveIpl("hei_bi_hw1_13_door")
      	RequestIpl("bkr_bi_hw1_13_int")
      	RequestIpl("ufo")
      	RemoveIpl('shr_int')
      	RemoveIpl("v_carshowroom")
      	RemoveIpl("shutter_open")
      	RemoveIpl("shutter_closed")
      	RemoveIpl("csr_inMission")
      	RequestIpl("v_carshowroom")
      	RequestIpl("shr_int")
      	RequestIpl("shutter_closed")
      	RequestIpl("smboat")
      	RequestIpl("cargoship")
      	RequestIpl("railing_start")
      	RemoveIpl("sp1_10_fake_interior")
      	RemoveIpl("sp1_10_fake_interior_lod")
      	RequestIpl("sp1_10_real_interior")
      	RequestIpl("sp1_10_real_interior_lod")
      	RemoveIpl("id2_14_during_door")
      	RemoveIpl("id2_14_during1")
      	RemoveIpl("id2_14_during2")
      	RemoveIpl("id2_14_on_fire")
      	RemoveIpl("id2_14_post_no_int")
      	RemoveIpl("id2_14_pre_no_int")
      	RemoveIpl("id2_14_during_door")
      	RequestIpl("id2_14_during1")
      	RequestIpl("coronertrash")
      	RequestIpl("Coroner_Int_on")
      	RemoveIpl("Coroner_Int_off")
      	RemoveIpl("bh1_16_refurb")
      	RemoveIpl("jewel2fake")
      	RemoveIpl("bh1_16_doors_shut")
      	RequestIpl("refit_unload")
      	RequestIpl("post_hiest_unload")
      	RequestIpl("Carwash_with_spinners")
      	RequestIpl("ferris_finale_Anim")
      	RemoveIpl("ch1_02_closed")
      	RequestIpl("ch1_02_open")
      	RequestIpl("AP1_04_TriAf01")
      	RequestIpl("CS2_06_TriAf02")
      	RequestIpl("CS4_04_TriAf03")
      	RemoveIpl("scafstartimap")
      	RequestIpl("scafendimap")
      	RemoveIpl("DT1_05_HC_REMOVE")
      	RequestIpl("DT1_05_HC_REQ")
      	RequestIpl("DT1_05_REQUEST")
      	RequestIpl("FINBANK")
      	RemoveIpl("DT1_03_Shutter")
      	RemoveIpl("DT1_03_Gr_Closed")
      	RequestIpl("ex_sm_13_office_01a")
      	RequestIpl("ex_sm_13_office_01b")
      	RequestIpl("ex_sm_13_office_02a")
      	RequestIpl("ex_sm_13_office_02b")
      	RequestIpl("RC12B_HospitalInterior")
      	RequestIpl("RC12B_Fixed")
      	RequestIpl("Plane_crash_trench")
      end,
    },
}

function PatchWorld(createblips)
    apw.game.setvoicechat()
    apw.game.disablelsservices()
    apw.game.disablevehrewards()
    apw.map.requestipl()
    apw.map.showzancudo()
    if createblips then
        apw.map.createnblip()
        apw.map.createzones()
    end
end

CreateThread(function()
    while true do
        Wait(0)
        if not IsPlayerSwitchInProgress() and not IsTextChatActive() and not IsWarningMessageActive() and not IsPauseMenuActive() and not IsSystemUiBeingDisplayed() and StartedPlaying then
            if IsControlJustPressed(0, 20) then
        			if (stepmap == 0) then
          				SetRadarBigmapEnabled(true, false)
          				stepmap = 1
        			elseif (stepmap == 1)then
          				SetRadarBigmapEnabled(true, false)
          				stepmap = 2
        			elseif (stepmap == 2) then
          				SetRadarBigmapEnabled(false, false)
          				stepmap = 3
              elseif (stepmap == 3) then
                  stepmap = 0
        			end
        		end
        		if (stepmap == 1) or (stepmap == 3) then
                if SETTINGS.FEATURES.PLAYER.ENABLE_SCOREBOARD then
                    if not IsAnyMenuOpened() then
        			          DisplayScoreboardThisFrame()
                    end
                end
        		end
            --[[if IsControlJustReleased(0, 25) then
                if (GetFollowPedCamViewMode() == 4) then
                    Wait(50)
                    if not IsPlayerFreeAiming(NetworkPlayerIdToInt()) then
                        SetFollowPedCamViewMode(0)
                    end
                else
                    Wait(50)
                    if not IsPlayerFreeAiming(NetworkPlayerIdToInt()) then
                        SetFollowPedCamViewMode(4)
                    end
                end
            end]]
        end
    end
end)

CreateThread(function()
    while true do
        Wait(0)
    		if IsPedSittingInAnyVehicle(PlayerPedId()) then
      			if DoesBlipExist(GetBlipFromEntity(GetVehiclePedIsIn(PlayerPedId(), false))) then
        				if GetBlipAlpha(GetBlipFromEntity(GetVehiclePedIsIn(PlayerPedId(), false))) ~= 0 then
        					  SetBlipAlpha(GetBlipFromEntity(GetVehiclePedIsIn(PlayerPedId(), false)), 0)
        				end
      			end
    		else
      			if DoesBlipExist(GetBlipFromEntity(GetVehiclePedIsIn(PlayerPedId(), true))) then
        				if GetBlipAlpha(GetBlipFromEntity(GetVehiclePedIsIn(PlayerPedId(), true))) ~= 255 then
        					  SetBlipAlpha(GetBlipFromEntity(GetVehiclePedIsIn(PlayerPedId(), true)), 255)
        				end
      			end
    		end
    end
end)

CreateThread(function()
    while true do
        Wait(0)
        if Vdist(GetEntityCoords(PlayerPedId(), true), apw.map.zones[1][1], apw.map.zones[1][2], apw.map.zones[1][3]) < 400 then
            if (GetPlayerTeam(NetworkPlayerIdToInt()) == 1) then
                SetEntityHealth(PlayerPedId(), GetEntityHealth(PlayerPedId())+1)
                Wait(2000)
            end
        elseif Vdist(GetEntityCoords(PlayerPedId(), true), apw.map.zones[2][1], apw.map.zones[2][2], apw.map.zones[2][3]) < 400 then
            if (GetPlayerTeam(NetworkPlayerIdToInt()) == 2) then
                SetEntityHealth(PlayerPedId(), GetEntityHealth(PlayerPedId())+1)
                Wait(2000)
            end
        elseif Vdist(GetEntityCoords(PlayerPedId(), true), apw.map.zones[3][1], apw.map.zones[3][2], apw.map.zones[3][3]) < 400 then
            SetEntityHealth(PlayerPedId(), GetEntityHealth(PlayerPedId())+2)
            Wait(2000)
        end
    end
end)

CreateThread(function()
    while true do
        Wait(0)
        apw.map.nerftrafic()
    end
end)

ready.client_world = true
