---------------------------------------------------------
-- RESSOURCE : Discord - Airport Wars
-- VERSION : 1.0
-- AUTEURS : Lobix300 & Rox10
--
-- Discord hook script for the Airport Wars server.
---------------------------------------------------------
local callbackUrl = "https://discordapp.com/api/webhooks/423654258777260035/DjS6YXeyYV8nQy-VlDs5wEOMjovhvDWJDd5kPbwN_FDy4IFRsVygtsxCpZSsVjqBO0lF"
local buffer = {}
local bufferId = 0
------------------------------------LOCAL FUNCTIONS-----------------------------------
-- Add to the buffer list
local function addToBuffer(contents, server)
    local bufferId = bufferId + 1
    local temp = {
      ["bufferId"] = bufferId,
      ["content"] = contents,
      ["asserver"] = server
    }
    table.insert(buffer, temp)
end

-- Pull the latest entry from the buffer
local function pullFromBuffer()
    if (next(buffer) ~= nil) then
        for i, callback in ipairs(buffer) do
            return callback
        end
    else
        return false
    end
end

local function removeFromBuffer(bufid)
    for i, callback in ipairs(buffer) do
        if (callback.bufferId == bufid) then
            buffer[i] = nil
        end
    end
end
--------------------------------- GLOBAL FUNCTIONS ------------------------------
function SendDiscordMessage(message, asserver)
    addToBuffer(message, asserver)
end
-------------------------------------SERVER THREAD-------------------------------------
CreateThread(function()
    AirportWarsThread(5, function()
        local entry = pullFromBuffer()
        if (entry ~= false) then
            PerformHttpRequest(callbackUrl, function(err, text, headers) end, "POST", json.encode({content = entry.content}), { ["Content-Type"] = "application/json" })
            removeFromBuffer(entry.bufferId)
            print("APW-DISCORDHOOK: Sent message: "..entry.content.." [buffer ID: "..entry.bufferId.."]")
        end
    end)
end)
-------------------------------------- EVENTS -----------------------------------------
RegisterServerEvent("airportwars:discord:message")
AddEventHandler("airportwars:discord:message", function(message, asserver)
    addToBuffer(message, asserver)
end)
---------------------------------------------------------------------------------------
CreateThread(function()
    SendDiscordMessage("The Airport Wars Server is now online.", true)
end)
