---------------------------------------------------------
-- RESSOURCE : System Management - Airport Wars
-- VERSION : 1.0
-- AUTEURS : Lobix300
--
-- Sys/DB Management script for the Airport Wars server.
---------------------------------------------------------
------------------------------------- VARIABLES ---------------------------------------
local Tunables = {}
local TunablesBeenDownloaded = false
---------------------------------------------------------------------------------------


-------------------------------------- FUNCTIONS --------------------------------------
function HasTunablesBeenDownloaded()
    return TunablesBeenDownloaded
end

function NetworkAccessTunable(tunableName)
    if (Tunables[tunableName] ~= nil) then
        return Tunables[tunableName]
    else
        return 1.0
    end
end

function NetworkRequestCloudTunables()
    exports["mysql"]:QueryResultAsync("SELECT * FROM apw_tunables", {}, function(tunables)
        for k, v in pairs(tunables) do
            Tunables[tunables[k].tunable] = json.decode(tunables[k].value).value
        end
        TunablesBeenDownloaded = true
    end)
end
---------------------------------------------------------------------------------------


-------------------------------------- EVENTS -----------------------------------------
AddEventHandler("airportwars:tunables:update", function(newlist)
    while not HasTunablesBeenDownloaded() do
        Wait(0)
    end
    for k, v in pairs(newlist) do
        Tunables[k] = v
    end
end)
---------------------------------------------------------------------------------------
