local masterList = {}
local count = 0

RegisterNetEvent('aw:spawnVehicle')
AddEventHandler('aw:spawnVehicle', function(vehicleList)
    spawnClientVehicle(vehicleList)
end)

RegisterNetEvent('aw:additionalVehicles')
AddEventHandler('aw:additionalVehicles', function(vehicleList)
    spawnAdditionalVehicle(vehicleList)
end)

RegisterNetEvent('aw:deleteByForce')
AddEventHandler('aw:deleteByForce', function(plateId)
    if (deleteVehicleByPlate(plateId)) then

    end
end)

RegisterNetEvent('aw:acceptMasterList')
AddEventHandler('aw:acceptMasterList', function(masterl)
    masterList = masterl
    --TriggerEvent("chatMessage", "vehicle sync", { 255,0,0}, " i got the master list "..dump(masterList))
end)

CreateThread(function()
  while true do
    Wait(math.random(1000,4000))
    --TriggerServerEvent("aw:clientResponse")
    if next(masterList) == nil then
        TriggerServerEvent("aw:designateSpawns")
        TriggerServerEvent("aw:giveMeMasterList")
    else
        -- TriggerEvent("chatMessage", "vehicle sync", { 255,0,0}, "vehs spawned ")
        TriggerServerEvent("aw:giveMeMasterList")
    end
  end
end)

local searchingRunning = false
CreateThread(function()
  while true do
    Wait(math.random(5000,8000))
    searchingRunning = true

    local vehicles = clientVehiclesPlates()
    TriggerServerEvent("aw:sendWhatClientSees", vehicles)
    if (next(vehicles) == nil) then
        if (count >= 2) then
            TriggerServerEvent("aw:noVehiclesOnServer")
            count = 0
        end
        count = count + 1
    end
    searchingRunning = false
  end
end)

CreateThread(function()
  while true do
    Wait(math.random(20000,40000))
    if not searchingRunning then
            if (callGC()) then
               -- TriggerServerEvent("aw:trace", "Client ran garbage collection")
            end
    end
  end
end)

--Run garbage collection on destroyed vehicles

CreateThread(function()
  while true do
    Wait(math.random(5000,9000))
    TriggerServerEvent("aw:checkMissingVehicles")
    Wait(math.random(1000,3000))
    TriggerServerEvent("aw:checkDerangedVehicles")

    --TriggerEvent("chatMessage", "vehicle sync", { 255,0,0}, " checking vehicles on server...")
  end
end)


function spawnClientVehicle(vehicles)
        --Spawn all server vehicles
            local vehicleNetIds = {}
            for i, veh in ipairs(vehicles) do

                  local vehicleHash = GetHashKey(veh.type)
                    RequestModel(vehicleHash)
                    while not HasModelLoaded(vehicleHash) do
                        RequestModel(vehicleHash)
                        Wait(1)
                    end
                    ClearAreaOfEverything(veh.x, veh.y, veh.z, 20, false, false, false, false)
                 local vehicle = CreateVehicle(vehicleHash, veh.x, veh.y, veh.z, veh.h, true, false)
                  
                 --SetEntitySomething(vehicle, true)
                   --SetEntityAsMissionEntity(vehicle, true, true)
                 --local vehId = NetworkGetNetworkIdFromEntity(vehicle)
                --SetNetworkIdExistsOnAllMachines(vehId)
                --SetNetworkIdCanMigrate(vehId)

                local vehPlate = GetVehicleNumberPlateText(vehicle)
                SetVehicleOnGroundProperly(vehicle)
                --local netIdString = vehId
                --local health = tonumber(GetVehicleEngineHealth(vehicle))

                table.insert(vehicleNetIds, vehPlate)

                SetModelAsNoLongerNeeded(vehicleHash)
            end
             TriggerServerEvent('aw:sendNetworkIds', vehicleNetIds)
            --Send all the network id's to the server

       -- TriggerServerEvent('aw:sendServerPlates')

end

function spawnAdditionalVehicle(vehicles)
      local vehicleNetIds = {}
            for i, veh in ipairs(vehicles) do

                  local vehicleHash = GetHashKey(veh.type)
                    RequestModel(vehicleHash)
                    while not HasModelLoaded(vehicleHash) do
                        RequestModel(vehicleHash)
                        Wait(1)
                    end
                     ClearAreaOfEverything(veh.x, veh.y, veh.z, 20, false, false, false, false)
                 local vehicle = CreateVehicle(vehicleHash, veh.x, veh.y, veh.z, veh.h, true, false)
               
                  --SetEntitySomething(vehicle, true)

                   --SetEntityAsMissionEntity(vehicle, true, true)
                 --local vehId = NetworkGetNetworkIdFromEntity(vehicle)
                --SetNetworkIdExistsOnAllMachines(vehId)
                --SetNetworkIdCanMigrate(vehId)

                local vehPlate = GetVehicleNumberPlateText(vehicle)
                SetVehicleOnGroundProperly(vehicle)
                --local netIdString = vehId
                --local health = tonumber(GetVehicleEngineHealth(vehicle))
                local temp = {
                    ["index"] = veh.index,
                    ["plate"] = vehPlate
                }
                table.insert(vehicleNetIds, temp)

                SetModelAsNoLongerNeeded(vehicleHash)
            end

            --Send all the network id's to the server

       -- TriggerServerEvent('aw:sendServerPlates')

TriggerServerEvent('aw:sendMoreSpawns', vehicleNetIds)
TriggerServerEvent("aw:giveMeMasterList")

end

function clientVehiclesPlates()
    vehicles = {}
    local handle,entity = FindFirstVehicle()
    if entity ~= nil then
        -- Event callback
        local health = tonumber(GetVehicleEngineHealth(entity))
        local position = GetEntityCoords(entity)
        local plate = GetVehicleNumberPlateText(entity)
        local running = GetIsVehicleEngineRunning(entity)
        for index, vehs in ipairs(masterList) do
            if (vehs.plate == plate and plate ~= nil and vehs.plate ~= 0) then
                    local temp = {
                    ["plate"] = plate,
                    ["health"] = health,
                    ["isRunning"] = running,
                    ["position"] = { table.unpack(position) }
                }
                table.insert(vehicles, temp)
            end
        end


        -- end event callback
    else
        return
    end

    local found = true
    while found do
        found,entity = FindNextVehicle(handle)
        if found then
            -- Event callback
             local health = tonumber(GetVehicleEngineHealth(entity))
            local position = GetEntityCoords(entity)
            local plate = GetVehicleNumberPlateText(entity)
            local running = GetIsVehicleEngineRunning(entity)
            for index, vehs in ipairs(masterList) do
                if (vehs.plate == plate and plate ~= nil and vehs.plate ~= 0) then
                        local temp = {
                        ["plate"] = plate,
                        ["health"] = health,
                        ["isRunning"] = running,
                        ["position"] = { table.unpack(position) }
                    }
                    table.insert(vehicles, temp)
                end
            end

            --end callback
        end
    end
    EndFindVehicle(handle)
    return vehicles
end

function deleteVehicleByPlate(plateIn)
    local handle,entity = FindFirstVehicle()
    if entity ~= nil then
           local plate = GetVehicleNumberPlateText(entity)
        -- Event callback
                if (plate == plateIn) then


                SetEntityAsMissionEntity(entity, true, true)
                DeleteVehicle(entity)

            end

        -- end event callback
    else
        return
    end

    local found = true
    while found do
        found,entity = FindNextVehicle(handle)
        if found then
            -- Event callback
              local plate = GetVehicleNumberPlateText(entity)
                  if (plate == plateIn) then


                SetEntityAsMissionEntity(entity, true, true)
                DeleteVehicle(entity)
            end

            --end callback
        end
    end
    EndFindVehicle(handle)
    return true
end

function callGC()

    local handle,entity = FindFirstVehicle()
    if entity ~= nil then
      local health = tonumber(GetVehicleEngineHealth(entity))
    if (health == -4000.0) then
       SetVehicleAsNoLongerNeeded(entity)
       --TriggerEvent("chatMessage", "vehicle sync", { 255,0,0}, " vehicle set for garbage collection "..GetVehicleNumberPlateText(entity))
       TriggerServerEvent("aw:trace", "Client ran garbage collection for veh ID:"..GetVehicleNumberPlateText(entity))
    end
    else
        return
    end

    local found = true
    while found do
        found,entity = FindNextVehicle(handle)
        if found then
            local health = tonumber(GetVehicleEngineHealth(entity))
    if (health == -4000.0) then
        SetVehicleAsNoLongerNeeded(entity)

        --TriggerEvent("chatMessage", "vehicle sync", { 255,0,0}, " vehicle set for gc "..GetVehicleNumberPlateText(entity))
         TriggerServerEvent("aw:trace", "Client ran garbage collection for veh ID:"..GetVehicleNumberPlateText(entity))
    end
        end
    end
    EndFindVehicle(handle)
    return true
end


function has_value(tab, val)
    for index, value in ipairs(tab) do
        if value == val then
            return true
        end
    end

    return false
end

function dump(o)
   if type(o) == 'table' then
      local s = '{ '
      for k,v in pairs(o) do
         if type(k) ~= 'number' then k = '"'..k..'"' end
         s = s .. '['..k..'] = ' .. dump(v) .. ','
      end
      return s .. '} '
   else
      return tostring(o)
   end
end
