--Prespawned Vehicles
-- add check for if a client is already spawninng vehicles
--Server


local slaveVehInfo = {}
local masterVehInfo = {} 


local respawnQueue = {}
local derangedVehicles = {}

--Internal variables, do not touch
local internalTimer = 0
local canRespawn = false
local clientSeesNone = false
local isClientSpawning = false
local emptyCounts = 0

RegisterServerEvent('aw:giveMeMasterList')
AddEventHandler('aw:giveMeMasterList', function() 
	TriggerClientEvent('aw:acceptMasterList', source, masterVehInfo)
	end)

RegisterServerEvent('aw:designateSpawns')
AddEventHandler('aw:designateSpawns', function()
 if (#masterVehInfo == 0) then
			loadMasterVehInfo()
		end
	if (vehiclesSpawned() == false and isClientSpawning == false) then
		
		isClientSpawning = true
		TriggerClientEvent('aw:spawnVehicle', source, masterVehInfo)

		Citizen.Trace("\n[vehSync] Spawning server vehicles through: "..GetPlayerName(source))

	else
		Citizen.Trace("\n[vehSync] Server vehicles are already spawned! [src: "..GetPlayerName(source).."]")
	end
	end)

local existOnServer = {}
RegisterServerEvent('aw:sendWhatClientSees')
AddEventHandler('aw:sendWhatClientSees', function(clientEyes)
	if (clientEyes ~= nil) then
		if (next(clientEyes) ~= nil) then  
			slaveVehInfo = clientEyes
			appendMasterFromSlaveData(clientEyes)
		end
	end
	
	if (clientEyes == nil or countElements(clientEyes) < 10) then
		if clientEyes == nil then 
			clientEyes = {}
		end
		emptyCounts = emptyCounts + 1

		--combine all client pools to see whats on the entire map
		for i, slave in ipairs(clientEyes) do
			if (isPlateInMaster(slave.plate)) then
				local index = getIndexOfMaster(slave.plate)
				if (has_value(existOnServer, index) == false) then
					table.insert(existOnServer, index)
				end
			end
		end

		if (emptyCounts >= 6) then
			emptyCounts = 0
			if (#respawnQueue < 10) then
			queueVehiclesFromWhatExists(existOnServer)
			Citizen.Trace("\n[vehSync] Queueing respawns for "..countElements(existOnServer).." vehicles through: "..GetPlayerName(source)..")")
			existOnServer = {}

			else 
				
				Citizen.Trace("\n[vehSync] Denied respawns for "..GetPlayerName(source)..") already in progress")
			end
		end
	else 
		emptyCounts = 0
	end 
  --Citizen.Trace("\n[vehSync] Client updated "..countElements(clientEyes).." vehicles ")

  end)

RegisterServerEvent('aw:trace')
AddEventHandler('aw:trace', function(message) 
	Citizen.Trace("\n[vehSync] "..message)
	end)

RegisterServerEvent('aw:noVehiclesOnServer')
AddEventHandler('aw:noVehiclesOnServer', function() 
	clientSeesNone = true
	end)

RegisterServerEvent('aw:sendNetworkIds')
AddEventHandler('aw:sendNetworkIds', function(inids) 
	isClientSpawning = false
	appendPlatesToMaster(inids)
	Citizen.Trace("\n[vehSync] Spawned all server vehicles: "..countElements(inids))

	end)

RegisterServerEvent('aw:sendMoreSpawns')
AddEventHandler('aw:sendMoreSpawns', function(inids) 
	
	isClientSpawning = false
	for i, veh in ipairs(masterVehInfo) do
		for j, plates in ipairs(inids) do
			if (veh.plate == 0 and veh.health == 0) then
				if (plates.index == i) then
					veh.plate = plates.plate
				end
			end
		end
	end
	end)

RegisterServerEvent('aw:checkMissingVehicles')
AddEventHandler('aw:checkMissingVehicles', function() 

	if (canRespawn == true and next(respawnQueue) ~= nil) then
		local respawnlist = {}
		for i, veh in ipairs(masterVehInfo) do
			if (veh.plate == 0 and veh.health == 0) then
				local vehadd = {
				["index"] = i,
				["type"] = veh.type,
				["x"] = veh.x,
				["y"] = veh.y,
				["z"] = veh.z,
				["h"] = veh.h
			}
			table.insert(respawnlist, vehadd)
       -- Citizen.Trace("\n[vehSync] "..dump(respawnlist))
   end
end

Citizen.Trace("\n[vehSync] Respawning "..#respawnQueue.." vehicles through: "..GetPlayerName(source))
     -- Citizen.Trace("\n[vehSync] "..dump(respawnlist))
     respawnQueue = {} 
     canRespawn = false
     isClientSpawning = true
     TriggerClientEvent('aw:additionalVehicles', source, respawnlist)

 end

 end)

RegisterServerEvent('aw:checkDerangedVehicles')
AddEventHandler('aw:checkDerangedVehicles', function() 
	if (vehiclesSpawned() == true) then
     -- Citizen.Trace("\n[vehSync] Deranged vehicles: "..#derangedVehicles)
     checkDerangedVehicles()

     for i, veh in ipairs(masterVehInfo) do
     	if (veh.inactiveTime >= derangedtime and veh.inactiveTime ~= 0) then
     		TriggerClientEvent("aw:deleteByForce", -1, veh.plate)

     		veh.health = 0
     		veh.isRunning = false
     		veh.position = {}

     		veh.plate = 0
     		Citizen.Trace("\n[vehSync] Deranged vehicle queued "..veh.type.." for respawn displaced "..veh.derangedDistance.." meters")
     		veh.derangedDistance = 0
     		veh.inactiveTime = 0
     		queueForRespawn(i)
     		derangedVehicles = {}


     	end
     end
 end
 end)

AddEventHandler('playerDropped', function(source)
  --Reinitalize the objectives if the server is empty - check first
  --if (#GetPlayers() == 1) then
    -- Server is empty, reinitialize objective states
    --masterVehInfo = {} 
    --loadMasterVehInfo()  
  --end
  -- If the client has disconnected during spawning vehicles
  
  end)

AddEventHandler('playerConnecting', function(playerName, setKickReason)
  --Reinitalize the objectives if the server is empty - check first
  --if (#GetPlayers() == 1) then
    -- Server is empty, reinitialize objective states
    --masterVehInfo = {} 
    --loadMasterVehInfo()  
  --end
  -- If the client has disconnected during spawning vehicles

  if (#GetPlayers() == 0) then
    -- Server is empty, reinitialize objective states
    

    masterVehInfo = {} 
    loadMasterVehInfo() 
    Citizen.Trace("\n[vehSync] Server is empty, initializing spawns for "..playerName)

end


end)

function loadMasterVehInfo()
	local count = 0
	for i, vehI in ipairs(vehicle_spawns) do
		local arr = {
		["type"] = vehI.type,
		["x"] = vehI.x,
		["y"] = vehI.y,
		["z"] = vehI.z,
		["h"] = vehI.h,
		["plate"] = 0,
		["position"] = {},
		["health"] = 0,
		["isRunning"] = false,
		["inactiveTime"] = 0,
		["derangedDistance"] = 0
	} 
	table.insert(masterVehInfo, arr)
	count = count + 1
end 
Citizen.Trace("\n[vehSync] Initialized "..count.." vehicles into vehSync\n")
end
--loadMasterVehInfo()

function appendPlatesToMaster(plates) 
if (countElements(plates) == countElements(masterVehInfo)) then
	for i, veh in ipairs(masterVehInfo) do
		veh.plate = plates[i]
	end
end
Citizen.Trace("\n[vehSync] Client created "..countElements(plates).." vehicles")
end

function isPlateInMaster(plate)
	for i, veh in ipairs(masterVehInfo) do
		if (veh.plate == plate) then
			return true
		end
	end
	return false
end

function findDerangedVehicles()
	local temp = {}
	for i, veh in ipairs(masterVehInfo) do
		if (veh.plate ~= 0 and next(veh.position) ~= nil) then
			local distance = distanceFrom(veh.x, veh.y, veh.z, veh.position[1], veh.position[2], veh.position[3])
			if (distance > distancecheck) then
				if (veh.health > -1) then
					if (veh.isRunning == false) then
						table.insert(temp, i)
						veh.derangedDistance = distance
					end
				end
			end
		end
	end
	return temp
end

function checkDerangedVehicles()
  --derangedVehicles = findDerangedVehicles()
  if (next(derangedVehicles) ~= nil) then
  	for i, index in ipairs(derangedVehicles) do
  		if (next(masterVehInfo[index].position) ~= nil) then
  			local distance = distanceFrom(masterVehInfo[index].x, masterVehInfo[index].y, masterVehInfo[index].z, masterVehInfo[index].position[1], masterVehInfo[index].position[2], masterVehInfo[index].position[3])
  			local crossCheck = masterVehInfo[index].derangedDistance - distance
  			if (crossCheck < 2 and crossCheck > -2) then
  				masterVehInfo[index].inactiveTime = masterVehInfo[index].inactiveTime + 1
          --masterVehInfo[index].derangedDistance = distance

      else
      	masterVehInfo[index].inactiveTime = 0
      	masterVehInfo[index].derangedDistance = 0
      end
  end
end
end
end

function getIndexOfMaster(plate)
	for i, veh in ipairs(masterVehInfo) do
		if (veh.plate == plate) then
			return i
		end
	end
	return false
end

function queueForRespawn(id) 
	if (has_value(respawnQueue, id) == false) then
		table.insert(respawnQueue, id)
	end
end

function appendMasterFromSlaveData(slavedata) 
for i, slave in ipairs(slavedata) do
	if (isPlateInMaster(slave.plate)) then
		local index = getIndexOfMaster(slave.plate)
		masterVehInfo[index].health = slave.health
		masterVehInfo[index].isRunning = slave.isRunning
		masterVehInfo[index].position = slave.position

		if (slave.health < -1) then
			masterVehInfo[index].health = 0
			masterVehInfo[index].isRunning = false
			masterVehInfo[index].position = {}
			masterVehInfo[index].plate = 0
			queueForRespawn(index)
        --TriggerClientEvent("aw:deleteByForce", source, slave.plate)
    end
end
end
end

function queueVehiclesFromWhatExists(whatexists)
	local count = 0
	
		local missingVehicles = {}
		local respawnCount = 0 
		for e, veh in ipairs(masterVehInfo) do
			local found = false 
			for i, exists in ipairs(whatexists) do
				if (e == exists) then
					found = true 
				end
			end
			if not found then 
				veh.health = 0
				veh.isRunning = false
				veh.position = {}

				veh.plate = 0

				veh.derangedDistance = 0
				veh.inactiveTime = 0
				queueForRespawn(e)
				respawnCount = respawnCount + 1
			end
		end
		

	
end

--using main thread
AirportWarsThread(5, function()

	if (vehiclesSpawned() == true and next(slaveVehInfo) ~= nil) then
		derangedVehicles = findDerangedVehicles()
	end
	if (vehiclesSpawned() == true) then
		checkDerangedVehicles()
	end
	internalTimer = internalTimer + 1
	if (internalTimer >= respawntime) then
		if (next(respawnQueue) ~= nil) then      
			if (canRespawn == false) then
				canRespawn = true
				Citizen.Trace("\n[vehSync] Next wave of respawns is ready for spawn ("..#respawnQueue.." vehicles)")
			end
		end
		internalTimer = 0
	end



	end)
function vehiclesSpawned()
	for i, veh in ipairs(masterVehInfo) do
		if (veh.plate ~= 0) then
			return true
		end
	end
	return false
end


--function vehCheck()
  --SetTimeout(15000, function()

    --vehCheck()
  --end)
--end
--vehCheck()

function countElements(tbl)
	local count = 0
	for i, veh in ipairs(tbl) do
		count = count + 1
	end
	return count
end

function distanceFrom(x1,y1,z1,x2,y2,z2) 
	return math.sqrt((x2 - x1)^2 + (y2 - y1)^2 + (z2 - z1)^2) 
end

function stringsplit(self, delimiter)
	local a = self:Split(delimiter)
	local t = {}

	for i = 0, #a - 1 do
		table.insert(t, a[i])
	end

	return t
end


function dump(o)
	if type(o) == 'table' then
		local s = '{ '
		for k,v in pairs(o) do
			if type(k) ~= 'number' then k = '"'..k..'"' end
			s = s .. '['..k..'] = ' .. dump(v) .. ','
		end
		return s .. '} '
	else
		return tostring(o)
	end
end

function has_value(tab, val)
	for index, value in ipairs(tab) do
		if value == val then
			return true
		end
	end

	return false
end

function difference(a, b)
	local ai = {}
	local r = {}
	for k,v in pairs(a) do r[k] = v; ai[v]=true end
	for k,v in pairs(b) do 
		if ai[v]~=nil then   r[k] = nil   end
	end
	return r
end

