resource_manifest_version "05cfa83c-a124-4cfa-a768-c24a5811d8f9"
description "Airport Wars"

dependency "airportwars_db"

client_scripts {
		"cl_gamemode.lua",
		"includes/cl_maeen.lua",
		"settings/cl_settings.lua",
		"gamemode/gxt/cl_entries.lua",
		"gamemode/init/cl_spawns.lua",
		"gamemode/init/cl_init.lua",
		"gamemode/teams/cl_teams.lua",
		"gamemode/anticheat/cl_anticheat.lua",
		"gamemode/sync/cl_weather.lua",
		"gamemode/deaths/cl_deaths.lua",
		"gamemode/intro/cl_introduction.lua",
		"gamemode/events/cl_events.lua",
		--"gamemode/objectives/cl_objectives.lua",
		"gamemode/market/cl_market.lua",
		"gamemode/randoms/cl_vehicles.lua",
		"gamemode/randoms/cl_crates.lua",
		"gamemode/lottery/cl_lottery.lua",
		--"gamemode/crates/cl_crates.lua",
		"gamemode/world/cl_world.lua",
		"gamemode/world/cl_interiors.lua",
		"gamemode/scoreboard/cl_scoreboard.lua",
		"gamemode/stores/cl_stores.lua",
		"gamemode/stores/cl_ammunation.lua",
		"gamemode/stores/cl_pegasus.lua",
		"gamemode/stores/cl_binco.lua",
		"gamemode/cheatcodes/cl_cheatcodes.lua",
		--"gamemode/hud/cl_hud.lua",
		"gamemode/ampi/cl_scadmin.lua",
		"gamemode/ampi/cl_noclip.lua",
		"gamemode/ampi/cl_ampimenu.lua",
		"gamemode/cellphone/cl_ifruit.lua",
		"gamemode/player/cl_pointing.lua",
		"gamemode/player/cl_rockstareditor.lua"
}

server_scripts {
		"@airportwars_db/sv_tunables.lua",
		"includes/sv_func.lua",
		"includes/sv_discordhook.lua",
		"sv_gamemode.lua",
		"gamemode/teams/sv_teams.lua",
		"gamemode/anticheat/sv_anticheat.lua",
		"gamemode/sync/sv_weather.lua",
		"gamemode/deaths/sv_deaths.lua",
		"gamemode/intro/sv_introduction.lua",
		"gamemode/events/sv_events.lua",
		--"gamemode/objectives/sv_objectives.lua",
		"gamemode/market/sv_market.lua",
		"gamemode/randoms/sv_vehicles.lua",
		"gamemode/randoms/sv_crates.lua",
		"gamemode/lottery/sv_lottery.lua",
		--"gamemode/crates/sv_crates.lua",
		"gamemode/scoreboard/sv_scoreboard.lua",
		"gamemode/stores/sv_stores.lua",
		"gamemode/stores/sv_ammunation.lua",
		"gamemode/stores/sv_pegasus.lua",
		"gamemode/stores/sv_binco.lua",
		"gamemode/cheatcodes/sv_cheatcodes.lua",
		--"gamemode/announcer/sv_announcer.lua",
		"gamemode/ampi/sv_scadmin.lua",
		"gamemode/ampi/sv_ampimenu.lua",
		"gamemode/cellphone/sv_ifruit.lua"
}

files {
    "loadscreen/index.html",
    "loadscreen/css/bootstrap.css",
    "loadscreen/css/stack-interface.css",
    "loadscreen/css/socicon.css",
    "loadscreen/css/lightbox.min.css",
    "loadscreen/css/flickity.css",
    "loadscreen/css/iconsmind.css",
    "loadscreen/css/jquery.steps.css",
    "loadscreen/css/theme.css",
    "loadscreen/css/custom.css",
    "loadscreen/js/jquery-3.1.1.min.js",
    "loadscreen/js/flickity.min.js",
    "loadscreen/js/easypiechart.js",
    "loadscreen/js/parallax.js",
    "loadscreen/js/typed.js",
    "loadscreen/js/datepicker.js",
    "loadscreen/js/isotope.js",
    "loadscreen/js/ytplayer.min.js",
    "loadscreen/js/lightbox.js",
    "loadscreen/js/granim.min.js",
    "loadscreen/js/jquery.steps.min.js",
    "loadscreen/js/countdown.min.js",
    "loadscreen/js/twitterfetcher.min.js",
    "loadscreen/js/spectragram.min.js",
    "loadscreen/js/smooth-scroll.min.js",
    "loadscreen/js/scripts.js",
		"loadscreen/img/innerbg.jpg",
		"loadscreen/img/headline-3.png",
    "loadscreen/music/Loading.ogg"
}



loadscreen "loadscreen/index.html"
