local heavy = {-1568386805, -1312131151, 1834241177, 1672152130, 1305664598, 125959754}
local rifles = {-1074790547, 961495388, -2084633992, 4208062921, -1357824103, -1063057011, 2132975508, 1649403952}
local handguns = {453432689, 3219281620, 1593441988, -1716589765, -1076751822, -771403250, 137902532, -598887786}
local lights = {324215364, -619010992, 736523883, 2024373456, -270015777, 1121678507}
local subs = {171789620, -1660422300, 2144741730, 3686625920, 1627465347}
local snipers = {100416529, 205991906, 177293209, -952879014}
local shotguns = {487013001, 2017895192, -1654528753, -494615257, -1466123874, 984333226, -275439685, 317205821}
local melee = {-1569615261, -1716189206, 1737195953, 1317494643, -1786099057, -2067956739, 1141786504, -102323637, -1834847097, -102973651, -656458692, -581044007, -1951375401, -538741184, -1810795771, 419712736, -853065399}
local thrown = {-1600701090, 615608432, 883325847, 1169823560}
local bombs = {-1813897027, 741814745, -1420407917}
local mini = {1119849093}
local gxt = {
    heavy = "DM_TK_HEAVY",
    rifles = "DM_TK_ARIFLE",
    handguns = "DM_TK_PISTOL",
    lights = "DM_TK_LIGHT",
    subs = "DM_TK_SUB",
    snipers = "DM_TK_SNIPE",
    shotguns = "DM_TK_SHOT",
    melee = "DM_TK_MELEE",
    bombs = "DM_TK_BOMB",
    mini = "DM_TK_MINI"
}

local function getweapontype(weaponofkiller, listtocheck)
    for k, v in pairs(listtocheck) do
        if weaponofkiller == v then
            return true
        else
            return false
        end
    end
end

RegisterServerEvent("airportwars:deaths:general:playerdied")

RegisterServerEvent("airportwars:deaths:onplayerkilled")
AddEventHandler("airportwars:deaths:onplayerkilled", function(killerid, data)
	  local victim = source
    local killerid = killerid
    local victimname = PatchPlayerName(data.victimteam, GetPlayerName(victim))
    local killername = PatchPlayerName(data.killerteam, GetPlayerName(killerid))
    local players = GetAllConnectedPlayers()
    SendDiscordMessage("**"..GetPlayerName(killerid).."** killed **"..GetPlayerName(victim).."**.", true)
    TriggerEvent("airportwars:sys:getuserfromid", killerid, function(Network)
        if (data.killerteam == data.victimteam) and (killerid ~= victim) then
            Network.RemoveFromStat("KILLS", 1, "kill", true)
            TriggerEvent("airportwars:deaths:punish", killerid)
        else
            Network.AddToStat("KILLS", 1, "kill", true)
            Network.AddToStat("SCORE", 2, "score", true)
            Network.AddToWalletBalance(500, true)
        end
    end)
    TriggerEvent("airportwars:sys:getuserfromid", victim, function(Network)
        Network.AddToStat("DEATHS", 1, "death", true)
    end)
		math.randomseed(tonumber(tostring(os.time()):reverse():sub(1,6)))
    local msg = math.random(0, 2)
		if getweapontype(data.weaponhash, heavy) then
				local gxtv = tostring(gxt.heavy.."0"..msg)
        local gxtt = tostring(gxt.heavy.."1"..msg)
        TriggerClientEvent("airportwars:simplenotify", victim, gxtv, -1, {killername}, true)
        TriggerClientEvent("airportwars:simplenotify", killerid, gxtt, -1, {victimname}, true)
		elseif getweapontype(data.weaponhash, rifles) then
        local gxtv = tostring(gxt.rifles.."0"..msg)
        local gxtt = tostring(gxt.rifles.."1"..msg)
				TriggerClientEvent("airportwars:simplenotify", victim, gxtv, -1, {killername}, true)
				TriggerClientEvent("airportwars:simplenotify", killerid, gxtt, -1, {victimname}, true)
		elseif getweapontype(data.weaponhash, bombs) then
        local gxtv = tostring(gxt.bombs.."0"..msg)
        local gxtt = tostring(gxt.bombs.."1"..msg)
				TriggerClientEvent("airportwars:simplenotify", victim, gxtv, -1, {killername}, true)
				TriggerClientEvent("airportwars:simplenotify", killerid, gxtt, -1, {victimname}, true)
		elseif getweapontype(data.weaponhash, snipers) then
        local gxtv = tostring(gxt.snipers.."0"..msg)
        local gxtt = tostring(gxt.snipers.."1"..msg)
				TriggerClientEvent("airportwars:simplenotify", victim, gxtv, -1, {killername}, true)
				TriggerClientEvent("airportwars:simplenotify", killerid, gxtt, -1, {victimname}, true)
		elseif getweapontype(data.weaponhash, mini) then
        local gxtv = tostring(gxt.mini.."0"..msg)
        local gxtt = tostring(gxt.mini.."1"..msg)
				TriggerClientEvent("airportwars:simplenotify", victim, gxtv, -1, {killername}, true)
				TriggerClientEvent("airportwars:simplenotify", killerid, gxtt, -1, {victimname}, true)
		elseif getweapontype(data.weaponhash, lights) then
        local gxtv = tostring(gxt.lights.."0"..msg)
        local gxtt = tostring(gxt.lights.."1"..msg)
				TriggerClientEvent("airportwars:simplenotify", victim, gxtv, -1, {killername}, true)
				TriggerClientEvent("airportwars:simplenotify", killerid, gxtt, -1, {victimname}, true)
		elseif getweapontype(data.weaponhash, subs) then
        local gxtv = tostring(gxt.subs.."0"..msg)
        local gxtt = tostring(gxt.subs.."1"..msg)
				TriggerClientEvent("airportwars:simplenotify", victim, gxtv, -1, {killername}, true)
				TriggerClientEvent("airportwars:simplenotify", killerid, gxtt, -1, {victimname}, true)
		elseif getweapontype(data.weaponhash, handguns) then
        local gxtv = tostring(gxt.handguns.."0"..msg)
        local gxtt = tostring(gxt.handguns.."1"..msg)
				TriggerClientEvent("airportwars:simplenotify", victim, gxtv, -1, {killername}, true)
				TriggerClientEvent("airportwars:simplenotify", killerid, gxtt, -1, {victimname}, true)
		elseif getweapontype(data.weaponhash, shotguns) then
        local gxtv = tostring(gxt.shotguns.."0"..msg)
        local gxtt = tostring(gxt.shotguns.."1"..msg)
				TriggerClientEvent("airportwars:simplenotify", victim, gxtv, -1, {killername}, true)
				TriggerClientEvent("airportwars:simplenotify", killerid, gxtt, -1, {victimname}, true)
		elseif getweapontype(data.weaponhash, melee) then
        local gxtv = tostring(gxt.melee.."0"..msg)
        local gxtt = tostring(gxt.melee.."1"..msg)
				TriggerClientEvent("airportwars:simplenotify", victim, gxtv, -1, {killername}, true)
				TriggerClientEvent("airportwars:simplenotify", killerid, gxtt, -1, {victimname}, true)
		else
				TriggerClientEvent("airportwars:simplenotify", victim, "DM_TICK1", -1, {killername}, true)
				TriggerClientEvent("airportwars:simplenotify", killerid, "DM_TICK2", -1, {victimname}, true)
		end
		for _, player in ipairs(players) do
				if player ~= victim and player ~= killerid then
            if getweapontype(data.weaponhash, heavy) then
                local gxt = tostring(gxt.heavy.."2"..msg)
                TriggerClientEvent("airportwars:simplenotify", player, gxt, -1, {killername, victimname}, true)
            elseif getweapontype(data.weaponhash, rifles) then
                local gxt = tostring(gxt.rifles.."2"..msg)
                TriggerClientEvent("airportwars:simplenotify", player, gxt, -1, {killername, victimname}, true)
            elseif getweapontype(data.weaponhash, bombs) then
                local gxt = tostring(gxt.bombs.."2"..msg)
                TriggerClientEvent("airportwars:simplenotify", player, gxt, -1, {killername, victimname}, true)
            elseif getweapontype(data.weaponhash, snipers) then
                local gxt = tostring(gxt.snipers.."2"..msg)
                TriggerClientEvent("airportwars:simplenotify", player, gxt, -1, {killername, victimname}, true)
            elseif getweapontype(data.weaponhash, mini) then
                local gxt = tostring(gxt.mini.."2"..msg)
                TriggerClientEvent("airportwars:simplenotify", player, gxt, -1, {killername, victimname}, true)
            elseif getweapontype(data.weaponhash, lights) then
                local gxt = tostring(gxt.lights.."2"..msg)
                TriggerClientEvent("airportwars:simplenotify", player, gxt, -1, {killername, victimname}, true)
            elseif getweapontype(data.weaponhash, subs) then
                local gxt = tostring(gxt.subs.."2"..msg)
                TriggerClientEvent("airportwars:simplenotify", player, gxt, -1, {killername, victimname}, true)
            elseif getweapontype(data.weaponhash, handguns) then
                local gxt = tostring(gxt.handguns.."2"..msg)
                TriggerClientEvent("airportwars:simplenotify", player, gxt, -1, {killername, victimname}, true)
            elseif getweapontype(data.weaponhash, shotguns) then
                local gxt = tostring(gxt.shotguns.."2"..msg)
								TriggerClientEvent("airportwars:simplenotify", player, gxt, -1, {killername, victimname}, true)
            elseif getweapontype(data.weaponhash, melee) then
                local gxt = tostring(gxt.melee.."2"..msg)
                TriggerClientEvent("airportwars:simplenotify", player, gxt, -1, {killername, victimname}, true)
						else
                TriggerClientEvent("airportwars:simplenotify", player, "DM_TICK6", -1, {killername, victimname}, true)
            end
				end
		end
end)

RegisterServerEvent("airportwars:deaths:onplayerdied")
AddEventHandler("airportwars:deaths:onplayerdied", function(type, diedguyteam, diedguypos)
	  local victim = source
    local victimname = PatchPlayerName(diedguyteam, GetPlayerName(victim))
    print(victimname)
    print(GetPlayerName(victim))
    local players = GetAllConnectedPlayers()
    SendDiscordMessage("**"..GetPlayerName(victim).."** died.", true)
    TriggerClientEvent("airportwars:simplenotify", victim, "DM_TK_YD1", -1, {}, true)
		for _, player in ipairs(players) do
				if (player ~= victim) then
            TriggerClientEvent("airportwars:simplenotify", player, "TICK_DIED", -1, {victimname}, true)
				end
		end
    TriggerEvent("airportwars:sys:getuserfromid", victim, function(Network)
        Network.AddToStat("DEATHS", 1, "death")
    end)
end)

RegisterServerEvent("airportwars:deaths:punish")
AddEventHandler("airportwars:deaths:punish", function(killerid)
    TriggerEvent("airportwars:sys:getuserfromid", killerid, function(Network)
        Network.AddToStat("WARNINGS_AMOUNT", 1, "warnings")
        local identifier = Network.GetInfo("IDENTIFIER")
        local teamkills = Network.GetStatFromString("WARNINGS_AMOUNT")
        if (teamkills == 1) then
            TriggerClientEvent("airportwars:notify", killerid, "TK_WARN_1", -1, {}, "CHAR_SOCIAL_CLUB", 0, "Airport Wars Team", "Warning", 2.0, true)
        elseif (teamkills == 2) then
            TriggerClientEvent("airportwars:notify", killerid, "TK_WARN_2", -1, {}, "CHAR_SOCIAL_CLUB", 0, "Airport Wars Team", "Warning", 2.0, true)
            SetTimeout(10000, function()
                --DropPlayer(killerid, "You have been kicked from the server for the following reason: team killing.")
                TriggerClientEvent("airportwars:deaths:punish", killerid)
                print("\nAPW_ANTI-TEAMKILL: "..tostring(GetPlayerName(killerid)).."/"..tostring(identifier).." has been kicked for teamkiling.")
                SendDiscordMessage("**"..GetPlayerName(killerid).."** has been kicked for teamkilling.", true)
            end)
        elseif (teamkills >= 3) then
            TriggerClientEvent("airportwars:notify", killerid, "TK_WARN_3", -1, {}, "CHAR_SOCIAL_CLUB", 0, "Airport Wars Team", "Warning", 2.0, true)
            exports["mysql"]:QueryAsync("INSERT INTO apw_bans (identifier, name, reason) VALUES (@identifier, @name, 'Teamkill')", {["@identifier"] = identifier, ["@name"] = GetPlayerName(source)})
            SetTimeout(10000, function()
                --DropPlayer(killerid, "You have been banned from the server for the following reason: team killing.")
                TriggerClientEvent("airportwars:deaths:punish", killerid)
                print("\nAPW_ANTI-TEAMKILL: "..tostring(GetPlayerName(killerid)).."/"..tostring(identifier).." has been banned for teamkiling.")
                SendDiscordMessage("**"..GetPlayerName(killerid).."** has been banned for teamkilling.", true)
            end)
        end
    end)
end)
