local entry_language = 0
local entries_en = {
    ["FE_THDR_GTAO"] = "Airport Wars",
    ["PM_PANE_LEAVE"] = "Exit Airport Wars",
    ["PM_SETTING_11"] = "Planes States Display",
    ["BLIP_OTHPLYR"] = "Teammates",
    ["APW_JOINED"] = "~a~ has joined.",
    ["FMMC_ENTER_PLAYERID"] = "Enter a Player ID (0-32)",
    ["SCADMIN_BAD_ID"] = "Bad Player ID, please try again.",
    ["SCADMIN_ENTER_KICKREASON"] = "Please specify a kick reason",
    ["SCADMIN_ENTER_BANREASON"] = "Please specify a ban reason",
    ["PLY_BEEN_KICKED"] = "~a~ has been kicked from the server for the following reason : ~a~.",
    ["PLY_BEEN_BANNED"] = "~a~ has been banned from the server for the following reason : ~a~.",
    ["APW_JOINED_ZC"] = "~a~ joined the ~r~<C>Zancudo Team</C>~w~.",
    ["APW_JOINED_LS"] = "~a~ joined the ~b~<C>Airport Team</C>~w~.",
    ["WLCM_TO_APW"] = "Welcome to Airport Wars!~n~Discord: ~y~discord.io/airportwars~w~~n~Dashboard: ~y~airportwars.com",
    ["KICKED_FROM_APW"] = "You are banned from the server as you didn't respect the rules. Thank you for your understanding.",
    ["BANNED_FROM_APW"] = "You are banned from the server as you didn't respect the rules. Thank you for your understanding.",
    ["MAN_APWBAN"] = "You have been manually banned from the server. Thank you for your understanding.",
    ["MAN_ADD_CASH"] = "A member of the Airport Wars Team added ~g~$~a~~w~ to your wallet.",
    ["MAN_REM_CASH"] = "A member of the Airport Wars Team removed ~r~$~a~~w~ from your wallet.",
    ["ERROR_AMNT_HIGH_ZC"] = "You can't join the Zancudo Team because the amount of players is higher.",
    ["ERROR_AMNT_HIGH_LS"] = "You can't join the Airport Team because the amount of players is higher.",
    ["FIRST_TIME_BONUS"] = "Thank you for playing on Airport Wars, we sent you $50.000, make good use of it!",
    ["AMPI_NOOBJ"] = "You don't have any objective for the moment.",
    ["FMMC_ENTER_CHEAT"] = "Enter a Cheat Code",
    ["FMMC_CHEAT_INVALID"] = "Invalid Cheat Code",
    ["CHEAT_USED"] = "This code has already been used.",
    ["CHEAT_404"] = "Unable to find the specified code.",
    ["CHEAT_STUFF_1"] = "The code has been applied, we sent you ~g~$25.000~w~, thanks for being an early player!",
    ["FIRST_WEEK_APW_HELPTEXT"] = "Welcome to Airport Wars !~n~Thanks for playing = all GTA$ and score is doubled this week !",
    ["PLYSRC_SCORE_CASH"] = "You scored ~a~ points and $~a~!",
    ["PLY_DELIV_PLANE_ZC"] = "~a~ has just delivered a plane from the Fort Zancudo Airbase!",
    ["PLY_DELIV_PLANE_LS"] = "~a~ has just delivered a plane from the Los Santos Airport!",
    ["TEAM_DELIV_PLANE_AWRD"] = "~a~ has just delivered a plane, your team was awarded $~a~.",
    ["PLY_DELIV_NORWRD"] = "Objectives are not rewarded unless there are more than ~a~ players online!",
    ["TK_WARN_1"] = "Team killing isn't allowed on this server. Next teamkill will result in a kick.",
    ["TK_WARN_2"] = "You'll be kicked in a few seconds for team killing. Next teamkill will result in a ban.",
    ["TK_WARN_3"] = "You are banned from the server as you didn't respect the rules. Thank you for your understanding.",
    ["PEG_BGHT_FREE"] = "Vehicle bought for free.~n~ Reason : ~a~",
    ["PEG_NOT_MONEY"] = "You don't have enough money for this vehicle.",
    ["PEG_VEH_COMING"] = "Your vehicle is being delivered to your base...",
    ["PEG_VEH_DELIVERED"] = "Your new vehicle has been delivered to your base. We hope you're very happy, sir.",
    ["PEG_VEH_DESTROYED"] = "Apologies. It seems your vehicle has been destroyed, come in the base to get a new for free.",
    ["BIN_OWN_SKIN"] = "You already have bought this skin.",
    ["BIN_NOT_MONEY"] = "You don't have enough money for this skin.",
    ["BIN_PREVSKIN_APPLIED"] = "Your previous skin has been applied to your character!",
    ["BIN_NEWSKIN_APPLIED"] = "Your new skin has been applied to your character!",
    ["BIN_DEFSKIN_APPLIED"] = "Your default team's skin has been applied to your character!",
    ["AMMU_BGHT_FREE"] = "Weapon added to your character for free.",
    ["AMMU_OWN_WEP"] = "You already have this weapon.",
    ["AMMU_NOWEP_FORAMMO"] = "You dont have a weapon for this ammo.",
    ["AMMU_NOT_MONEY"] = "You don't have enough money for this weapon.",
    ["AMMU_NOT_MONEY_AMMO"] = "You don't have enough money for these ammos.",
    ["SPCL_VEH_DSTR"] = "The special ~y~~a~~w~ has been destroyed.",
    ["SPCL_VEH_DSTR_IN_2"] = "The special ~y~~a~~w~ will detonate in 2 minutes.",
    ["SPCL_VEH_DSTRED"] = "The special ~y~~a~~w~ has detonated after ~a~ minutes.",
    ["RDM_SC20M"] = "~y~Special Crate Drop in 20 minutes.",
    ["RDM_SC10M"] = "~y~Special Crate Drop in 10 minutes.",
    ["RDM_SC2M"] = "~y~Special Crate Drop inbound.",
    ["RDM_SCTKN"] = "~y~~a~ picked up the Special Crate.",
    ["RDM_SCDAX"] = "~y~Special Crate Drop destroyed after ~a~ minutes.",
    ["RDM_SCC1"] = "Crate Contents:~n~+ $5000~n~+ Minigun~n~+ Body Armor",
    ["LOTTERY_OPEN"] = "A lottery has begun! You can enter for $1000.",
    ["LOTTERY_ENTER_KEY"] = "to enter in the lottery.",
    ["NOCLIP_HELPTEXT"] = "Noclip enabled !~n~Move with ~INPUT_MOVE_UP_ONLY~ ~INPUT_MOVE_DOWN_ONLY~ ~INPUT_MOVE_LEFT_ONLY~ ~INPUT_MOVE_RIGHT_ONLY~~n~~n~Current Speed : ~a~~n~Switch speed with ~INPUT_SPRINT~"
}

local function SetEntryLanguage(id)
    entry_language = id
end

local function GetEntryLanguage()
    return entry_language
end

local function GetEntriesForCurrentLanguage()
    if (GetCurrentLanguageId() == 0) then
        return entries_en
    elseif (GetCurrentLanguageId() == 1) then
        return entries_fr or entries_en
    elseif (GetCurrentLanguageId() == 2) then
        return entries_de or entries_en
    elseif (GetCurrentLanguageId() == 3) then
        return entries_it or entries_en
    elseif (GetCurrentLanguageId() == 4) then
        return entries_es or entries_en
    elseif (GetCurrentLanguageId() == 5) then
        return entries_pt or entries_en
    elseif (GetCurrentLanguageId() == 6) then
        return entries_pl or entries_en
    elseif (GetCurrentLanguageId() == 7) then
        return entries_ru or entries_en
    elseif (GetCurrentLanguageId() == 8) then
        return entries_ko or entries_en
    elseif (GetCurrentLanguageId() == 9) then
        return entries_zh or entries_en
    elseif (GetCurrentLanguageId() == 10) then
        return entries_ja or entries_en
    elseif (GetCurrentLanguageId() == 11) then
        return entries_mx or entries_en
    end
end

CreateThread(function()
    local entries = GetEntriesForCurrentLanguage()
    for k, v in pairs(entries) do
        AddTextEntry(k,  v)
    end
    SetEntryLanguage(GetCurrentLanguageId())
    ready.entries = true
end)

CreateThread(function()
    while true do
        Wait(100)
        if (GetCurrentLanguageId() ~= GetEntryLanguage()) then
            local entries = GetEntriesForCurrentLanguage()
            for k, v in pairs(entries) do
                if (type(k) == "string") then
                    AddTextEntry(k,  v)
                elseif (type(k) == "number") then
                    AddTextEntryByHash(k, v)
                end
            end
            SetEntryLanguage(GetCurrentLanguageId())
        end
    end
end)
