---------------------------------------------------------
-- RESSOURCE : Introduction - Airport Wars
-- VERSION : 1.0
-- AUTEURS : Lobix300
--
-- Introduction script for the Airport Wars server.
---------------------------------------------------------
-------------------------------------- EVENTS -----------------------------------------
RegisterServerEvent("airportwars:intro:check")
AddEventHandler("airportwars:intro:check", function()
    TriggerEvent("airportwars:sys:getuserfromid", source, function(Network)
        if Network.GetStatFromString("IS_TUTORIAL_DONE") then
            TriggerClientEvent("airportwars:intro:update", source, false)
        else
            TriggerClientEvent("airportwars:intro:update", source, true)
        end
    end)
end)

RegisterServerEvent("airportwars:intro:finished")
AddEventHandler("airportwars:intro:finished", function()
    TriggerEvent("airportwars:sys:getuserfromid", source, function(Network)
        Network.SetStat("IS_TUTORIAL_DONE", true)
        TriggerClientEvent("airportwars:intro:done", source)
    end)
end)

RegisterServerEvent("airportwars:intro:checkbonus")
AddEventHandler("airportwars:intro:checkbonus", function()
    TriggerEvent("airportwars:sys:getuserfromid", source, function(Network)
        if not Network.GetStatFromString("HAS_RECEIVED_BONUS") then
            TriggerClientEvent("airportwars:notify", source, "FIRST_TIME_BONUS", -1, {}, "CHAR_SOCIAL_CLUB", 0, "Airport Wars Team", "Welcome", 1.0, true)
            Network.AddToWalletBalance(50000, false)
            Network.SetStat("HAS_RECEIVED_BONUS", true)
        end
    end)
end)

RegisterServerEvent("airportwars:intro:checktips")
AddEventHandler("airportwars:intro:checktips", function()
    TriggerEvent("airportwars:sys:getuserfromid", source, function(Network)
        --if not Network.GetStatFromString("APW_TIPS_HELPTEXTS") then
            TriggerClientEvent("airportwars:intro:showtips", source, false)
        --end
    end)
end)

RegisterServerEvent("airportwars:intro:confirmtips")
AddEventHandler("airportwars:intro:confirmtips", function()
    TriggerEvent("airportwars:sys:getuserfromid", source, function(Network)
        Network.SetStat("APW_TIPS_HELPTEXTS", true)
    end)
end)
---------------------------------------------------------------------------------------
