---------------------------------------------------------
-- RESSOURCE : Weapon Shop - Airport Wars
-- VERSION : 1.0
-- AUTEURS : Lobix300
--
-- Weapon Shop for the Airport Wars server.
---------------------------------------------------------
------------------------------------- VARIABLES ---------------------------------------
local ammunation = {}
local itemsloaded = false
------------------------------------- VARIABLES --------------------------------------


------------------------------------- FUNCTIONS --------------------------------------
local function getWeapons(identifier)
	  return exports["mysql"]:QueryScalar("SELECT temp_weapons FROM apw_weapons WHERE identifier = @identifier", {["@identifier"] = identifier})
end

local function buyWeapon(source, gxtname, model, identifier, ammo, ind, category)
  	local getweapons = getWeapons(identifier)
  	local weapons = {}
  	local weapons = json.decode(getweapons)
    if not tablecontains(weapons, model) then
  	    table.insert(weapons, model)
    end
  	local new_weapons = json.encode(weapons)
  	exports["mysql"]:QueryAsync("UPDATE apw_weapons SET temp_weapons = @new_weapons WHERE identifier = @username", {["@username"] = identifier, ["@new_weapons"] = new_weapons})
  	TriggerClientEvent("airportwars:weapons:playerhavemoney", source, gxtname, model, true, ammo, ind, category)
end

local function getPrice(cat, ind)
		if (cat == "melee") then
				return ammunation.melee[ind].price
		elseif (cat == "handgun") then
				return ammunation.handgun[ind].price
		elseif (cat == "shotgun") then
				return ammunation.shotgun[ind].price
		elseif (cat == "submachine") then
				return ammunation.submachine[ind].price
		elseif (cat == "assault") then
				return ammunation.assault[ind].price
		elseif (cat == "sniper") then
				return ammunation.sniper[ind].price
		elseif (cat == "heavy") then
				return ammunation.heavy[ind].price
		elseif (cat == "thrown") then
				return ammunation.thrown[ind].price
		elseif (cat == "special_ammo") then
				return ammunation.special_ammo[ind].price
		end
end
---------------------------------------------------------------------------------------


-------------------------------------- EVENTS -----------------------------------------
RegisterServerEvent("airportwars:weapons:getlist")
AddEventHandler("airportwars:weapons:getlist", function(source)
    while not itemsloaded do
        Wait(0)
    end
		for k, v in pairs(ammunation) do
				for k, v in pairs(v) do
						if (v.price ~= nil) then
								v.price = round(v.price * NetworkAccessTunable("WEAPONS_SHOP_MULTIPLIER"))
						end
				end
		end
		TriggerClientEvent("airportwars:weapons:getlist", source, ammunation.categories, ammunation.melee, ammunation.handgun, ammunation.shotgun, ammunation.submachine, ammunation.assault, ammunation.sniper, ammunation.heavy, ammunation.thrown, ammunation.special_ammo)
end)

RegisterServerEvent("airportwars:weapons:checkmoney")
AddEventHandler("airportwars:weapons:checkmoney", function(gxtname, model, category, ammo, ind, clientprice)
    local source = source
		local price = getPrice(category, ind)
		if (price ~= clientprice) then
				TriggerEvent("airportwars:anticheat:flagged", source, "Cheating Base Armory Prices")
				return
		end
		local identifier = GetPlayerIdentifiers(source)[1]
    local getweapons = getWeapons(identifier)
  	local weapons = {}
  	local weapons = json.decode(getweapons)
		--if tablecontains(weapons, model) then
    --    TriggerClientEvent("airportwars:weapons:playerhavemoney", source, gxtname, model, false)
    --    TriggerClientEvent("airportwars:notify", source, "AMMU_BGHT_FREE", -1, {}, "CHAR_AMMUNATION", 0, "Base Armory", "", 0.3, false)
		--else
        TriggerEvent("airportwars:sys:getuserfromid", source, function(Network)
      			if (Network.GetStatFromString("WALLET_BALANCE") >= price) then
      				  buyWeapon(source, gxtname, model, identifier, ammo, ind, category)
      				  Network.RemoveFromWalletBalance(price)
                print("\nAPW_AMMUNATION: "..tostring(GetPlayerName(source)).." purchased a "..tostring(model)..", $"..tostring(price).." taken from his wallet.")
      			--elseif (Network.GetStatFromString("BANK_BALANCE") >= price) then
      			--	  buyWeapon(source, gxtname, model, identifier)
      			--	  Network.RemoveFromBankBalance(price)
            --    print("\nAPW_AMMUNATION: "..tostring(GetPlayerName(source)).." purchased a "..tostring(model)..", $"..tostring(price).." taken from his bank account.")
      			else
      				  TriggerClientEvent("airportwars:notify", source, "AMMU_NOT_MONEY", -1, {}, "CHAR_AMMUNATION", 0, "Base Armory", "", 0.3, false)
      			end
        end)
		--end
end)

RegisterServerEvent("airportwars:weapons:checkmoneyammo")
AddEventHandler("airportwars:weapons:checkmoneyammo", function(model, category, ind, giveone, clientprice)
    local source = source
		local price = getPrice(category, ind)
		if (price ~= clientprice) then
				TriggerEvent("airportwars:anticheat:flagged", source, "Cheating Base Armory Prices")
				return
		end
  	TriggerEvent("airportwars:sys:getuserfromid", source, function(Network)
    		if (Network.GetStatFromString("WALLET_BALANCE") >= price) then
    			  Network.RemoveFromWalletBalance(price)
    			  TriggerClientEvent("airportwars:weapons:playerhavemoneyforammo", source, model, giveone)
            print("\nAPW_AMMUNATION: "..tostring(GetPlayerName(source)).." purchased ammo for "..tostring(model)..", $"..tostring(price).." taken from his wallet.")
    		--elseif (Network.GetStatFromString("BANK_BALANCE") >= price) then
    		--	  Network.RemoveFromBankBalance(price)
    		--	  TriggerClientEvent("airportwars:weapons:playerhavemoneyforammo", source, model)
        --    print("\nAPW_AMMUNATION: "..tostring(GetPlayerName(source)).." purchased ammo for "..tostring(model)..", $"..tostring(price).." taken from his bank account.")
    		else
    			  TriggerClientEvent("airportwars:notify", source, "AMMU_NOT_MONEY_AMMO", -1, {}, "CHAR_AMMUNATION", 0, "Base Armory", "", 0.3, false)
    		end
  	end)
end)

RegisterServerEvent("airportwars:weapons:getweapons")
AddEventHandler("airportwars:weapons:getweapons", function()
		local source = source
  	local identifier = GetPlayerIdentifiers(source)[1]
  	local temp_weapons = exports["mysql"]:QueryScalar("SELECT temp_weapons FROM apw_weapons WHERE identifier = @identifier", {["@identifier"] = identifier})
		local perm_weapons = exports["mysql"]:QueryScalar("SELECT perm_weapons FROM apw_weapons WHERE identifier = @identifier", {["@identifier"] = identifier})
  	local temp_weapons = json.decode(temp_weapons)
		local perm_weapons = json.decode(perm_weapons)
  	for i, v in ipairs(temp_weapons) do
  		  TriggerClientEvent("airportwars:weapons:giveweapon", source, "temp", v)
  	end
		for i, v in ipairs(perm_weapons) do
  		  TriggerClientEvent("airportwars:weapons:giveweapon", source, "perm", v)
  	end
end)

AddEventHandler("airportwars:deaths:general:playerdied", function()
    local identifier = GetPlayerIdentifiers(source)[1]
	  exports["mysql"]:QueryAsync("UPDATE apw_weapons SET temp_weapons = '[]' WHERE identifier = @identifier", {["@identifier"] = identifier})
    print("\nAPW_AMMUNATION: temp_weapons entry in database for : "..tostring(GetPlayerName(source)).."/"..tostring(identifier).." wiped. Reason : player died.")
end)
---------------------------------------------------------------------------------------


-------------------------------------- THREADS ----------------------------------------
CreateThread(function()
		while not StoreFileLoaded do
				Wait(0)
		end
		ammunation = json.decode(GetItemsList("ammunation"))
    itemsloaded = true
end)
---------------------------------------------------------------------------------------
