---------------------------------------------------------
-- RESSOURCE : Vehicle Shop - Airport Wars
-- VERSION : 1.0
-- AUTEURS : Lobix300
--
-- Vehicle Shop for the Airport Wars server.
---------------------------------------------------------
------------------------------------- VARIABLES ---------------------------------------
local pegasus = {}
local itemsloaded = false
---------------------------------------------------------------------------------------


------------------------------------- FUNCTIONS --------------------------------------
local function getVehicles(identifier)
	  return exports["mysql"]:QueryScalar("SELECT vehicles FROM apw_vehicles WHERE identifier = @identifier", {["@identifier"] = identifier})
end

local function getlastVehicle(identifier)
	  return exports["mysql"]:QueryScalar("SELECT lastvehicle FROM apw_vehicles WHERE identifier = @identifier", {["@identifier"] = identifier})
end

local function buyVehicle(source, identifier, type, model, blipid)
  	local getVehicles = getVehicles(identifier)
  	local vehicles = {}
  	local vehicles = json.decode(getVehicles)
  	table.insert(vehicles, model)
  	local new_vehicles = json.encode(vehicles)
  	exports["mysql"]:QueryAsync("UPDATE apw_vehicles SET vehicles = @new_vehicles WHERE identifier = @identifier", {["@identifier"] = identifier, ["@new_vehicles"] = new_vehicles})
  	TriggerClientEvent("airportwars:pegasus:playerhavemoney", source, type, model, blipid)
end

local function getPrice(cat, ind)
		if (cat == "free") then
				return pegasus.free[ind].price
		elseif (cat == "armored") then
				return pegasus.armored[ind].price
		elseif (cat == "military") then
				return pegasus.military[ind].price
		elseif (cat == "sports") then
				return pegasus.sports[ind].price
		elseif (cat == "motorcycles") then
				return pegasus.motorcycles[ind].price
		elseif (cat == "planes") then
				return pegasus.planes[ind].price
		elseif (cat == "helicopters") then
				return pegasus.helicopters[ind].price
		end
end
---------------------------------------------------------------------------------------


-------------------------------------- EVENTS -----------------------------------------
RegisterServerEvent("airportwars:pegasus:getlist")
AddEventHandler("airportwars:pegasus:getlist", function(source)
		while not itemsloaded do
				Wait(0)
		end
    for k, v in pairs(pegasus) do
        for k, v in pairs(v) do
            if (v.price ~= nil) then
                v.price = round(v.price * NetworkAccessTunable("VEHICLES_SHOP_MULTIPLIER"))
            end
        end
    end
		TriggerClientEvent("airportwars:pegasus:getlist", source, pegasus.categories, pegasus.free, pegasus.armored, pegasus.military, pegasus.sports, pegasus.motorcycles, pegasus.planes, pegasus.helicopters)
end)

RegisterServerEvent("airportwars:pegasus:checkmoney")
AddEventHandler("airportwars:pegasus:checkmoney", function(category, ind, type, model, blipid, clientprice)
    local source = source
		local price = getPrice(category, ind)
		if (price ~= clientprice) then
				TriggerEvent("airportwars:anticheat:flagged", source, "Cheating Vehicle Shop Prices")
				return
		end
		local identifier = GetPlayerIdentifiers(source)[1]
		local getVehicles = getVehicles(identifier)
		local vehicles = {}
    local vehicles = json.decode(getVehicles)
		if tablecontains(vehicles, model) then
				if (category ~= "free") then
        		TriggerClientEvent("airportwars:notify", source, "PEG_BGHT_FREE", -1, {"Previously bought."}, "CHAR_PEGASUS_DELIVERY", 0, "Pegasus", "", 0.3, false)
				end
        TriggerClientEvent("airportwars:pegasus:playerhavemoney", source, type, model, blipid)
		else
        TriggerEvent("airportwars:sys:getuserfromid", source, function(Network)
      			if (Network.GetStatFromString("WALLET_BALANCE") >= price) then
        				buyVehicle(source, identifier, type, model, blipid)
        				Network.RemoveFromWalletBalance(price)
    						print("\nAPW_PEGASUS: "..tostring(GetPlayerName(source)).." purchased a vehicle "..tostring(model)..", $"..tostring(price).." taken from his wallet.")
      			--[[elseif (Network.GetStatFromString("BANK_BALANCE") >= price) then
        				buyVehicle(source, model, identifier, blipid)
        				Network.RemoveFromBankBalance(price)]]
                exports["mysql"]:QueryAsync("UPDATE apw_vehicles SET lastvehicle = @lastvehicle WHERE identifier = @identifier", {["@identifier"] = identifier, ["@lastvehicle"] = model})
      			else
      				  TriggerClientEvent("airportwars:notify", source, "PEG_NOT_MONEY", -1, {}, "CHAR_PEGASUS_DELIVERY", 0, "Pegasus", "", 0.3, false)
      			end
        end)
		end
end)
---------------------------------------------------------------------------------------


-------------------------------------- THREADS ----------------------------------------
CreateThread(function()
		while not StoreFileLoaded do
				Wait(0)
		end
		pegasus = json.decode(GetItemsList("pegasus"))
		itemsloaded = true
end)
---------------------------------------------------------------------------------------
