---------------------------------------------------------
-- RESSOURCE : Teams - Airport Wars
-- VERSION : 1.0
-- AUTEURS : Lobix300
--
-- Team management script for the Airport Wars server.
---------------------------------------------------------
------------------------------------- VARIABLES ---------------------------------------
StartedPlaying = false
CanCheckGodmod = false
blips = {}
tags = {}
---------------------------------------------------------------------------------------

local function GetPlayers()
    local players = {}
    for i = 0, 32 do
        if NetworkIsPlayerActive(i) then
            table.insert(players, i)
        end
    end
    return players
end

-------------------------------------- EVENTS -----------------------------------------
RegisterNetEvent("airportwars:teams:setteam")
AddEventHandler("airportwars:teams:setteam", function(team)
    if (team == 1) then
        PlayerSwitch(SETTINGS.LOCATIONS.SPAWNS.PLAYERS.ZANCUDOTEAM)
        SetRichPresence("Zancudo Team")
    elseif (team == 2) then
        PlayerSwitch(SETTINGS.LOCATIONS.SPAWNS.PLAYERS.AIRPORTTEAM)
        SetRichPresence("Airport Team")
    end
    while not IsPlayerSwitchInProgress() do
        Wait(0)
    end
    playerselection.destroycam()
    SetPlayerTeam(NetworkPlayerIdToInt(), team)
    NetworkSetVoiceChannel(team)
    PatchPlayer()
    PatchWorld(true)
    TriggerServerEvent("airportwars:network:initializecash")
    TriggerServerEvent("airportwars:ampimenu:initialize")
    TriggerServerEvent("airportwars:anticheat:isadmin", GetPlayerServerId())
    while IsPlayerSwitchInProgress() do
        Wait(0)
    end
    TriggerServerEvent("airportwars:skinshop:checklastskin")
    SetPlayerControl(NetworkPlayerIdToInt(), true, 0)
    SetTimeout(1000, function()
        StartedPlaying = true
        TriggerEvent("airportwars:objectives:tempfix") --TEMP
        TriggerEvent("airportwars:notify", "WLCM_TO_APW", -1, {}, "CHAR_SOCIAL_CLUB", 1, "Airport Wars", "Welcome", 0.5, true)
    end)
    NetworkFadeInEntity(PlayerPedId(), 1)
    SetPlayerInvincible(NetworkPlayerIdToInt(), true)
    SetTimeout(5000, function()
        SetPlayerInvincible(NetworkPlayerIdToInt(), false)
        SetTimeout(500, function()
            CanCheckGodmod = true
        end)
    end)
    SetTimeout(15000, function()
        TriggerServerEvent("airportwars:intro:checkbonus")
    end)
    SetTimeout(7500, function()
        TriggerServerEvent("airportwars:intro:checktips")
    end)
end)
---------------------------------------------------------------------------------------


-------------------------------------- THREADS ----------------------------------------
CreateThread(function()
    while true do
        Wait(0)
        while not StartedPlaying do
            Wait(0)
        end
        if (GetPlayerTeam(NetworkPlayerIdToInt()) == 1) then
            if Vdist(GetEntityCoords(), 0.0, 0.0, 0.0) < 0 then
                CanCheckGodmod = false
                if not GetPlayerInvincible(NetworkPlayerIdToInt()) then
                    SetEntityInvincible(PlayerPedId(), true)
                end
            else
                if GetPlayerInvincible(NetworkPlayerIdToInt()) then
                    SetEntityInvincible(PlayerPedId(), false)
                end
                CanCheckGodmod = true
            end
        elseif (GetPlayerTeam(NetworkPlayerIdToInt()) == 2) then
            if Vdist(GetEntityCoords(), 0.0, 0.0, 0.0) < 0 then
                CanCheckGodmod = false
                if not GetPlayerInvincible(NetworkPlayerIdToInt()) then
                    SetEntityInvincible(PlayerPedId(), true)
                end
            else
                if GetPlayerInvincible(NetworkPlayerIdToInt()) then
                    SetEntityInvincible(PlayerPedId(), false)
                end
                CanCheckGodmod = true
            end
        end
    end
end)

CreateThread(function()
    while true do
        Wait(0)
        while not StartedPlaying do
            Wait(0)
            for id = 0, 32 do
                if (id ~= NetworkPlayerIdToInt()) then
                    if NetworkIsPlayerActive(id) then
                        SetEntityLocallyInvisible(GetPlayerPed(id))
                    end
                end
            end
        end
        return
    end
end)

CreateThread(function()
    while true do
        Wait(1000)
        while not StartedPlaying do
            Wait(0)
        end
        if (GetPlayerTeam(NetworkPlayerIdToInt()) == 1) then
            if (GetPedRelationshipGroupHash(PlayerPedId())  ~= "zancudoteam") then
                SetPedRelationshipGroupHash(PlayerPedId(), "zancudoteam")
            end
        elseif (GetPlayerTeam(NetworkPlayerIdToInt()) == 2) then
            if (GetPedRelationshipGroupHash(PlayerPedId())  ~= "airportteam") then
                SetPedRelationshipGroupHash(PlayerPedId(), "airportteam")
            end
        end
        for id = 0, 32 do
            if NetworkIsPlayerActive(id) then
                if (id ~= NetworkPlayerIdToInt() and GetPlayerPed(id) ~= nil) then
                    if (GetPlayerTeam(id) == 1) then
                        if (GetPedRelationshipGroupHash(GetPlayerPed(id))  ~= "zancudoteam") then
                            SetPedRelationshipGroupHash(GetPlayerPed(id), "zancudoteam")
                        end
                    elseif (GetPlayerTeam(id) == 2) then
                        if (GetPedRelationshipGroupHash(GetPlayerPed(id))  ~= "airportteam") then
                            SetPedRelationshipGroupHash(GetPlayerPed(id), "airportteam")
                        end
                    end
                end
            end
        end
    end
end)

CreateThread(function()
    while not StartedPlaying do
        Wait(0)
    end
    while true do
        Wait(0)
        local players = GetPlayers()
        for _, id in ipairs(players) do
            if ((IsPedAPlayer(GetPlayerPed(id))) and ((id ~= NetworkPlayerIdToInt())) and (GetPlayerPed(id) ~= 0) and (GetPlayerTeam(id) == GetPlayerTeam(NetworkPlayerIdToInt()))) then
                if not IsMpGamerTagActive(tags[id]) then
                    tags[id] = CreateMpGamerTag(GetPlayerPed(id), NetworkPlayerGetName(id), false, false, "", 0)
                    SetMpGamerTagName(tags[id], NetworkPlayerGetName(id))
                    SetMpGamerTagAlpha(tags[id], 2, 255)
                else
                    if (GetProfileSetting(222) == 1) then
                        if HasEntityClearLosToEntity(PlayerPedId(), GetPlayerPed(id), 17) then
                            SetMpGamerTagVisibility(tags[id], 0, true)
                            SetMpGamerTagVisibility(tags[id], 2, true)
                        else
                            SetMpGamerTagVisibility(tags[id], 0, false)
                            SetMpGamerTagVisibility(tags[id], 2, false)
                        end
                    else
                        SetMpGamerTagVisibility(tags[id], 0, false)
                        SetMpGamerTagVisibility(tags[id], 2, false)
                    end
                end
            else
                if (tags[id] ~= nil) then
                    RemoveMpGamerTag(tags[id])
                    tags[id] = nil
                end
            end
        end
    end
end)

CreateThread(function()
    while not StartedPlaying do
        Wait(0)
    end
    while true do
        Wait(0)
        local players = GetPlayers()
        for _, id in ipairs(players) do
            if ((IsPedAPlayer(GetPlayerPed(id))) and ((id ~= NetworkPlayerIdToInt()) and (GetPlayerPed(id) ~= 0)) and (GetPlayerTeam(id) == GetPlayerTeam(NetworkPlayerIdToInt()))) then
                if not DoesBlipExist(GetBlipFromEntity(GetPlayerPed(id))) then
                    blips[id] = AddBlipForEntity(GetPlayerPed(id))
                    SetBlipScale(blips[id], 0.7)
                    SetBlipAlpha(blips[id], 255)
                    SetBlipHighDetail(blips[id], 1)
                    SetBlipShowCone(blips[id], 0)
                    SetBlipDisplay(blips[id], 4)
                    N_0x75a16c3da34f1245(blips[id], 0)
                    SetBlipAsShortRange(blips[id], 0)
                    if GetPlayerTeam(id) == 1 then
                        SetBlipColour(blips[id], 75)
                    elseif GetPlayerTeam(id) == 2 then
                        SetBlipColour(blips[id], 3)
                    end
                    HideNumberOnBlip(blips[id])
                    SetBlipNameToPlayerName(blips[id], id)
                    SetBlipCategory(blips[id], 7)
                else
                    if not IsPedFatallyInjured(GetPlayerPed(id)) then
                        if IsPedInAnyVehicle(GetPlayerPed(id), 0) then
                            local model = GetEntityModel(GetVehiclePedIsIn(GetPlayerPed(id), 0))
                            --[[if DoesEntityExist(zancudoplane) then
                                if (GetVehiclePedIsIn(GetPlayerPed(id), 0) == zancudoplane) then
                                    sprite = 251
                                end
                            elseif DoesEntityExist(airportplane) then
                                if (GetVehiclePedIsIn(GetPlayerPed(id), 0) == airportplane) then
                                    sprite = 251
                                end]]
                            if (model == GetHashKey("rhino")) then
                                sprite = 421
                            elseif (model == GetHashKey("khanjali")) then
                                sprite = 598
                            elseif (model == GetHashKey("nokota")) then
                                sprite = 582
                            elseif (model == GetHashKey("alphaz1")) then
                                sprite = 578 -- not sure
                            elseif (model == GetHashKey("molotok")) then
                                sprite = 579
                            elseif (model == GetHashKey("mogul")) then
                                sprite = 580 -- not sure
                            elseif (model == GetHashKey("pyro")) then
                                sprite = 581
                            elseif (model == GetHashKey("starling")) then
                                sprite = 572
                            elseif (model == GetHashKey("howard")) then
                                sprite = 582 -- not sure
                            elseif (model == GetHashKey("tula")) then
                                sprite = 585
                            elseif (model == GetHashKey("microlight")) then
                                sprite = 577
                            elseif (model == GetHashKey("bombushka")) then
                                sprite = 585
                            elseif (model == GetHashKey("volatol")) then
                                sprite = 600
                            elseif (((model == GetHashKey("lazer")) or (model == GetHashKey("besra"))) or (model == GetHashKey("hydra"))) then
                                sprite = 424
                            elseif ((((model == GetHashKey("technical")) or (model == GetHashKey("insurgent"))) or (model == GetHashKey("limo2"))) or (model == GetHashKey("insurgent2"))) then
                                sprite = 426
                            elseif IsThisModelAPlane(model) then
                                sprite = 423
                            elseif IsThisModelAHeli(model) then
                                sprite = 422
                            else
                                sprite = 1
                            end
                        else
                            sprite = 1
                            ShowHeadingIndicatorOnBlip(blips[id], 1)
                        end
                        if GetBlipSprite(blips[id]) ~= sprite then
                            SetBlipSprite(blips[id], sprite)
                            ShowHeadingIndicatorOnBlip(blips[id], 0)
                        end
                    else
                        if (GetBlipSprite(blips[id]) ~= 274) then
                            SetBlipSprite(blips[id], 274)
                            ShowHeadingIndicatorOnBlip(blips[id], 0)
                        end
                    end
                    if ((GetBlipColour(blips[id]) ~= 75) and (GetPlayerTeam(id) == 1)) then
                        SetBlipColour(blips[id], 75)
                    end
                    if ((GetBlipColour(blips[id]) ~= 3) and (GetPlayerTeam(id) == 2)) then
                        SetBlipColour(blips[id], 3)
                    end
                    if (GetBlipSprite(blips[id]) ~= 1) then
                        SetBlipRotation(blips[id], Round(GetEntityPhysicsHeading(GetPlayerPed(id))))
                        SetBlipScale(blips[id], 1.15)
                    else
                        SetBlipScale(blips[id], 0.7)
                    end
                    SetBlipNameToPlayerName(blips[id], id)
                end
            else
                if (blips[id] ~= nil) then
                    RemoveBlip(blips[id])
                    blips[id] = nil
                end
            end
        end
    end
end)
---------------------------------------------------------------------------------------
ready.client_teams = true
