---------------------------------------------------------
-- RESSOURCE : Teams - Airport Wars
-- VERSION : 1.0
-- AUTEURS : Lobix300
--
-- Team management script for the Airport Wars server.
---------------------------------------------------------

local ZancudoPlayers = {}
local AirportPlayers = {}

-------------------------------------- EVENTS -----------------------------------------
RegisterServerEvent("airportwars:teams:setteam")
AddEventHandler("airportwars:teams:setteam", function(team)
    local source = source
    TriggerEvent("airportwars:sys:getuserfromid", source, function(Network)
        Network.SetInfo("TEAM", team, true)
        if (team == 1) then
            table.insert(ZancudoPlayers, Network.GetInfo("IDENTIFIER"))
            SendDiscordMessage("**"..GetPlayerName(source).."** joined the Zancudo Team (online: "..tostring(#GetAllConnectedPlayers()).."/32).", true)
        elseif (team == 2) then
            table.insert(AirportPlayers, Network.GetInfo("IDENTIFIER"))
            SendDiscordMessage("**"..GetPlayerName(source).."** joined the Airport Team (online: "..tostring(#GetAllConnectedPlayers()).."/32).", true)
        end
        TriggerClientEvent("airportwars:teams:setteam", source, team)
        local players = GetAllConnectedPlayers()
 				for _, player in ipairs(players) do
 						if (player ~= source) then
                if (team == 1) then
 								    TriggerClientEvent("airportwars:simplenotify", player, "APW_JOINED_ZC", -1, {"<C>"..GetPlayerName(source).."</C>"}, true)
                elseif (team == 2) then
                    TriggerClientEvent("airportwars:simplenotify", player, "APW_JOINED_LS", -1, {"<C>"..GetPlayerName(source).."</C>"}, true)
                end
 						end
 				end
        print("\nAPW_TEAMMANAGER: Team "..tostring(team).." has been applied to "..tostring(GetPlayerName(source)).."/"..tostring(Network.GetInfo("IDENTIFIER"))..".")
    end)
    if IsAnyEventActive() then
        TriggerEvent("airportwars:events:checkstats", source)
    end
end)

RegisterServerEvent("airportwars:teams:deleteplayer")
AddEventHandler("airportwars:teams:deleteplayer", function(team, identifier)
    if (team == 1) then
        table.remove(ZancudoPlayers, identifier)
    elseif (team == 2) then
        table.remove(AirportPlayers, identifier)
    end
end)
---------------------------------------------------------------------------------------
